;DISK ASM Editor
;
;SCPU is Simulated CPU
;AL is SCPU OP CODE LENGTH ($2A)

;Program uses $0240 to $1391, source file is contained $1391+
;$1300 G - To enter from the monitor

Source code storage:

2 byte line # 1byte/char plus line terminator 0D
Repeated chars:  1 char plus repeat count.

Symbol table:

6 chars/label HIMEM decending


LOCATIONS:

	;CIN =  $FFEB ;GET CHARACTER FROM KEYBOARD
	;COUT = $FFEE ;PRINT CHARACTER
	;LOAD = $FFF4 ;SET LOAD FLAG
	;SAVE = $FFF7 ;SET SAVE FLAG
;
	;ZERO PAGE MEMORY LOCATIONS
	;$00,01	 =
	;$02,03	 = PTR to KYBD BUFF @ $0080
	;$04,05	 =
	;$06,07	 =
	;$0A,$0B = START OF LABEL TABLE
	;$10,$11 = CURRENT POSITION IN TEXT
	;$16,$17 = START OF TEXT MEMORY
	;$18,$19 = END OF  AVAILABLE MEMORY
	;$1A,$1B = END OF SOURCE TEXT
	;$24,$25 = INTERPRETIVE POINTER FOR P-CODE,return address
	;$2A	 = AL SCPU OPCODE LEN
	;$2C,$2D = PERMANENTLY SET TO ZERO
	;$44,$45 = CURRENT ADDRESS FOR ASSEMBLY
	;$50,$51,$52 = UP TO THREE BYTES INSTRUCTION
	;$80-$B7 = KEYBOARD BUFFER
	;$E4,5	 = TBL POINTER SCPU FUN ADD @ $0780
	;$E6,7	 = ADD OF FUN executed
	;$FA,B	 = PC SCPU store


;Initialized values:

;0PG ADD Data		0PG ADD	Data		0PG ADD	Data							
						
							
00	80		76	0C		D6	21
02	80		78	7E		D7	10
16	40		80	49		D8	92
17	14		0A	0		D9	19
18	FF		0B	0		DA	74
19	3F		1A	40		DB	7C
24	1		1B	14		DC	2A
25	6		2E	FF		DD	69
38	14		2F	FF		DE	0
42	1		3A	36		DF	1
58	80		3C	0A		E0	2
60	40		4A	3		E1	2
62	10		4E	EA		EA	4
65	0C		4F	EA		EE	37
67	3		5B	B0		F2	5
70	0		5D	40		F4	6
71	0		5E	20		FC	42
72	50		7A	6C		FF	FF
74	2		D4	44			
							
Other locations are = 00		


;$12C9, 12CA  Start of source file (lo,hi)
;$12CB, 12CC  HIMEM top of available memory.
;$12FA, 12FB  =($000A,B) for symbol table linking
;$12FC, 12FD  Used to bias the placement of obj code during A3 assembly, 0 as supplied
;$12FE, 12FF  End of source file automatically incremented as text is entered

Psuedo code areas:

047C-0492	SCPU 0D

04C0-04D3	SCPU 0E

05D3-05E4

05F8-0600

0600-068F	CMD PROCESSOR

0690-06FF	A CMDs

0700-074F	SCPU 1A

0750-077F	PRINT

07D0-0822	DELETE

082D-0964	RENUMBER

09F6-09FB

0A0D-0A1F

0BF6-0BF8

0C00-0C6B

0CAD-0D3D

0D6C-0C8D

0DC9-10CF	**??

111C-115E

11EA-1200 

1230-1258

140C-1419


;SCPU OP CODES AS PCODE:


047C-0492	SCPU 0D
04C0-04D3	SCPU 0E

;OP CODES 80-A7 are SCPU code ?


;SCPU SUBROUTINES:



32

50

6A

74

7B

83	 JSR ($07C0)=$0C30

8D 	 JSR ($079A)=$047C
8E 	 JSR ($079C)=$04C0
8F	 JSR ($079E)=$03D4

96	 JSR ($07AC)=$0626
97	 JSR ($07AE)=$02CB

9A	 JSR ($07B4)=$0700

9C	 JSR ($07B8)=$095D
9D 	 JSR ($07BA)=$0989
9E	 JSR ($07BC)=$0985

A0	 JSR ($07C0)=$0C30
A1	 JSR ($07C2)=$0AF0

A7	 JSR ($07CE)=$0E25
		  
		  
			


1179	SCPU FUNCTION ENTRY
11CF	PC SCPU INC
11DC	SCPU MODE RETURN.Execute following P-code
15		MC6502	RETURN to machine code

DOS calls:

$2340	INECHO	@13E0
$2343	PRINT (A)

$24FF	TERMIN+9

$252F	KBINP+7

$2A7D	SETERR
$2A84	EXCOM

$2CF7	SWAP

$2D73	STROUT
$2D6A	CRLF
$2D92	PBCD
$2D9B	PRTHEX


0200  4C 60 11   JMP $1160		;called 1157,152F
;--------------------------; SCPU 0 INPUT an fill LINE BUFFER
0203  A0 01      LDY #$01		;reset Y buffer offset
0205  88         DEY			;Y=BUFFOFFSET
0206  30 FB      BMI $0203		;reset Y buffer offset
0208  10 02      BPL $020C
020A  85 FF      STA $FF		;FF= input char  temp store
020C  20 88 05   JSR $0588		;do INPUT/OUTPUT
020F  91 02      STA ($02),Y		;store char in buffer.(here after INIT Y)	
0211  C9 0D      CMP #$0D		;CR ?
0213  F0 20      BEQ $0235		;do EOL
0215  C9 5F      CMP #$5F		;Rubout ?
0217  F0 EC      BEQ $0205		;DEC Y OFFSET -remove char
0219  C9 5E      CMP #$5E		;^SHIFT-N ?
021B  F0 E6      BEQ $0203		;line DEL
021D  C9 09      CMP #$09		;CTRL-I ?
021F  F0 08      BEQ $0229		;do TAB
0221  C9 7F      CMP #$7F		;Delete ?
0223  F0 E5      BEQ $020A		;yes store CHARTMP
0225  C9 20      CMP #$20		;SPACE ? yes store
0227  30 E3      BMI $020C		;CTRL chars ? but dont store
0229  C8         INY			;for next char store
022A  C0 38      CPY #$38		;BUFF length full ?
022C  D0 DE      BNE $020C		;no get next char and store
022E  A9 07      LDA #$07
0230  20 43 03   JSR $0343
0233  D0 D0      BNE $0205
;--------------------------;EOL
0235  A9 0A      LDA #$0A
0237  88         DEY
0238  30 F6      BMI $0230
023A  A5 02      LDA $02
023C  85 00      STA $00
023E  D0 0E      BNE $024E


0240  A2 00      LDX #$00	;SCPU 01,L,H AL=3; CMP WITH ($00,0) 
0242  F0 02      BEQ $0246
0244  A2 06      LDX #$06	;SCPU 02,L,H AL=3; CMP WITH ($00,6),X =SRC PTR 
0246  BA 24      LDA ($24),Y
0248  30 0C      BMI $0256
024A  41 00      EOR ($00,X)
024C  F0 03      BEQ $0251
024E  4C CF 11   JMP $11CF		;PC SCPU INC			
;--------------------------	;SCPU 1F AL=1; NOP
0251  A0 02      LDY #$02		;Y=2
0253  4C 84 02   JMP $0284		;

;--------------------------		;next char in source is 		
0256  29 7F      AND #$7F		;A=80 CAPITAL
0258  A8         TAY			;A=81 DECIMAL
0259  A1 00      LDA ($00,X)		;A=82 A-F
025B  D9 67 02   CMP $0267,Y		;A=83 CTRL char or SPACE
025E  30 EE      BMI $024E
0260  D9 6B 02   CMP $026B,Y
;--------------------------	;SCPU 06
0263  30 EC      BMI $0251
0265  10 E7      BPL $024E
;--------------------------
0267  41 30 41 00       		;A 0 A
026B  5B 3A 47 21 00      		;[:G!

;--------------------------	;SCPU 03,L,H AL=3; MOVE 16 bit numbers L TO H		
0270  20 A0 04   JSR $04A0		;get next arg
0273  AA         TAX
0274  B1 24      LDA ($24),Y
0276  A8         TAY
0277  B5 00      LDA $00,X
0279  99 00 00   STA $0000,Y
027C  B5 01      LDA $01,X
027E  99 01 00   STA $0001,Y
0281  4C CF 11   JMP $11CF		;PC SCPU INC		
;--------------------------	;SCPU 05,L AL=2; JMP REL
0284  B1 24      LDA ($24),Y		;OPERAND L, Y=1		
0286  AA         TAX			;save L
0287  18         CLC
0288  65 24      ADC $24
028A  85 24      STA $24		;PCL SCPU add L
028C  8A         TXA			;restore L
028D  30 04      BMI $0293		;05,L is NEG -JMP back
028F  A9 00      LDA #$00
0291  F0 02      BEQ $0295		;always
0293  A9 FF      LDA #$FF
0295  65 25      ADC $25
0297  85 25      STA $25		;PCH SCPU
0299  4C A9 02   JMP $02A9
;--------------------------	;SCPU 04,L,H AL=3; JMP ABS
029C  B1 24      LDA ($24),Y
029E  AA         TAX
029F  C8         INY
02A0  B1 24      LDA ($24),Y
02A2  85 25      STA $25		;PCH SCPU
02A4  86 24      STX $24		;PCL SCPU
02A6  4C 79 11   JMP $1179		;SCPU FUNCTION ENTRY
	
;--------------------------		;*** PC SCPU INCREMENT ***;(also @ 11CF)
02A9  18         CLC
02AA  98         TYA
02AB  65 24      ADC $24		;ADD (Y) to PC
02AD  85 24      STA $24		;PCL SCPU
02AF  A5 25      LDA $25
02B1  69 00      ADC #$00
02B3  85 25      STA $25		;PCH SCPU
02B5  4C 79 11   JMP $1179		;SCPU FUNCTION ENTRY
;--------------------------
02B8  B1 24      LDA ($24),Y	;SCPU 12,L AL=2; RTS
02BA  AA         TAX
02BB  A8         TAY		
02BC  68         PLA		;SCPU 11 AL=1; RTS from PCODE SUB
02BD  85 24      STA $24		;PCL SCPU
02BF  68         PLA
02C0  85 25      STA $25		;PCH SCPU
02C2  68         PLA
02C3  85 2A      STA $2A		;$2A=
02C5  CA         DEX
02C6  10 BC      BPL $0284		;FUN 12 exit RTS REL
02C8  4C CF 11   JMP $11CF		;FUN 11 exit. PC SCPU INC
;--------------------------	;SCPU 17 AL=1; 
02CB  03 04 00   MOV $04-$00       
02CE  11     	 RTS (RETURN)
02CF  FF      
;--------------------------	;SCPU 13,L AL=2; INC 16-bit value in L
02D0  B1 24      LDA ($24),Y		;
02D2  AA         TAX
02D3  F6 00      INC $00,X
02D5  D0 02      BNE $02D9
02D7  F6 01      INC $01,X
02D9  4C CF 11   JMP $11CF		;PC SCPU INC		
;--------------------------	;SCPU 14,L AL=2; DEC L
02DC  B1 24      LDA ($24),Y	
02DE  20 ED 02   JSR $02ED
02E1  4C CF 11   JMP $11CF		;PC SCPU INC		
;--------------------------	;SCPU 15 AL=1; return to MC6502 routine
02E4  E6 24      INC $24		;PCL SCPU
02E6  D0 02      BNE $02EA
02E8  E6 25      INC $25		;PCH SCPU
02EA  6C 24 00   JMP ($0024)		;Used by Exit,Load,Save always
					;Print,Reseq,Delete ONLY if source exists
;--------------------------
02ED  AA         TAX			;called @ 02DE
02EE  B5 00      LDA $00,X		;called @ 03F8
02F0  D0 02      BNE $02F4
02F2  D6 01      DEC $01,X
02F4  D6 00      DEC $00,X
02F6  60         RTS
;--------------------------		;called @ 0354 PRINT routine
02F7  20 56 03   JSR $0356
02FA  D0 4B      BNE $0347
02FC  A4 3F      LDY $3F
02FE  B8         CLV
02FF  60         RTS
;--------------------------	;SCPU 10 ,XX,YY AL=3; Editor only routine
0300  86 26      STX $26
0302  86 EC      STX $EC		;input 16-bit decimal to XX,branch YY IF OVERFLOW >65535
0304  B1 24      LDA ($24),Y		;text @ (06,7) ; (08) = #of digits
0306  AA         TAX
0307  A9 00      LDA #$00
0309  95 00      STA $00,X
030B  95 01      STA $01,X
030D  A4 26      LDY $26
030F  B1 06      LDA ($06),Y
0311  29 0F      AND #$0F
0313  85 E7      STA $E7
0315  8A         TXA
0316  A8         TAY
0317  A9 3C      LDA #$3C
0319  20 84 0A   JSR $0A84		;
031C  B0 09      BCS $0327
031E  E6 26      INC $26
0320  C6 08      DEC $08
0322  D0 E9      BNE $030D
0324  4C CF 11   JMP $11CF		;PC SCPU INC		
;--------------------------		;BRANCH on byte three
0327  A0 02      LDY #$02
0329  4C 84 02   JMP $0284
;--------------------------		;(here after Cold Start init of PG0)
					;Part SCPU routine with TXTPTR updating
032C  A5 1A      LDA $1A		;called @ 117B ONLY ?	
032E  8D FE 12   STA $12FE
0331  A5 1B      LDA $1B		;($1A,B)=$12FE,F NXTSRCBUFFPTR >$1391+
0333  8D FF 12   STA $12FF		;NXTTXTADD in src buffer
0336  B1 24      LDA ($24),Y		;SCPU OP CODE [(0601)],Y=0, A=$96
0336  20 3B 15   JSR $153B		;SCPU OP CODE [(0601)],Y=0, A=$96   ***

0339  4C 7E 11   JMP $117E		;contin cold start
;--------------------------
033C  A9 0D      LDA #$0D		;'CR'
033E  20 43 03   JSR $0343		;'(A)''LF'
0341  A9 0A      LDA #$0A		;'LF'
;--------------------------
0343  C9 0A      CMP #$0A		;PRINT CHAR
0345  D0 11      BNE $0358
0347  C6 FC      DEC $FC		;$FC=
0349  D0 04      BNE $034F
034B  A9 42      LDA #$42
034D  85 FC      STA $FC		;$FC=42
034F  AD E0 12   LDA $12E0		;($FC)=($12E0)=42 @INIT
0352  C5 FC      CMP $FC
0354  30 A1      BMI $02F7
0356  A9 0A      LDA #$0A		;'LF'
0358  24 FF      BIT $FF
035A  84 3F      STY $3F		;$3F= ,Y=
035C  48         PHA
035D  4C F6 0B   JMP $0BF6		;Print (A)
;--------------------------

0360  20 41 03   JSR $0341		;CALLED @$03EE by  SCPU 08
0363  38         SEC		;SCPU 06 ? Err --^,'string',00,0D
0364  A5 06      LDA $06
0366  E5 02      SBC $02		;
0368  F0 09      BEQ $0373		;BPL for DSKDRV# prompt mod
036A  AA         TAX
036B  A9 2D      LDA #$2D		;'-'
036D  20 43 03   JSR $0343		;Print (A)
0370  CA         DEX
0371  D0 FA      BNE $036D
0373  A9 5E      LDA #$5E		;'^'
0375  20 43 03   JSR $0343		;Print (A)
0378  A9 0D      LDA #$0D
037A  20 43 03   JSR $0343		;Print 'CR'
;--------------------------	
037D  20 41 03   JSR $0341	;SCPU 07 AL=VARIABLE; 'LF,string',00,CR	
0380  B1 24      LDA ($24),Y	;SCPU 24 AL=VARIABLE; 'string',00,CR
0382  C8         INY			;MSG PTR eg 'INIZ ?'
0383  C9 00      CMP #$00		;end
0385  F0 0A      BEQ $0391
0387  20 43 03   JSR $0343		;Print (A)
038A  C9 0D      CMP #$0D		;CR MSG End
038C  D0 F2      BNE $0380		;Get next char for msg print
038E  20 41 03   JSR $0341
0391  98         TYA
0392  18         CLC
0393  65 24      ADC $24
0395  85 24      STA $24		;PCL SCPU
0397  A9 00      LDA #$00
0399  65 25      ADC $25
039B  85 25      STA $25		;PCH SCPU
039D  4C 79 11   JMP $1179		;SCPU FUNCTION ENTRY
;--------------------------	;SCPU 09 AL=5  XX,YY,AA,BB
03A0  20 A0 04   JSR $04A0
03A3  AA         TAX
03A4  B1 24      LDA ($24),Y		;Y=2
03A6  85 E4      STA $E4
03A8  C8         INY			;Y=3
03A9  B1 24      LDA ($24),Y
03AB  A8         TAY
03AC  38         SEC
03AD  B5 00      LDA $00,X
03AF  F9 00 00   SBC $0000,Y		;compare 16bit values @ 0-pg
03B2  85 E5      STA $E5		;XX,XX+1 and YY,YY+1
03B4  B5 01      LDA $01,X		;branch on BB
03B6  F9 01 00   SBC $0001,Y
03B9  A2 02      LDX #$02
03BB  05 E5      ORA $E5
03BD  F0 05      BEQ $03C4
03BF  CA         DEX
03C0  B0 02      BCS $03C4
03C2  A2 04      LDX #$04
03C4  8A         TXA
03C5  EA         NOP
03C6  EA         NOP
03C7  25 E4      AND $E4
03C9  D0 03      BNE $03CE
03CB  4C CF 11   JMP $11CF		;Advance PC and execute
;--------------------------
03CE  A0 04      LDY #$04		;called @ 03C9 only ???
03D0  6C 8A 07   JMP ($078A)		;$0284
;--------------------------		
03D3  FF         
03D4  03 16 10 	 MOV $16-$10  	;SCPU 0F AL=1       		
03D7  09 10 02 1A 04
		 BRA $04 =$03DF 
03DC  04 8E 04   JMP $048E  
03DF  11   	 RTS (RETURN)
;--------------------------
03E0  A2 26      LDX #$26
03E2  A0 7E      LDY #$7E
03E4  A9 6A      LDA #$6A
03E6  20 2A 05   JSR $052A
03E9  4C 02 0D   JMP $0D02
;--------------------------	;SCPU 08 AL=VARIABLE; STROUT
03EC  E6 06      INC $06
03EE  4C 60 03   JMP $0360		;? ---^,string,00,0D
;--------------------------
03F1  00         BRK			;called 04F9,04DE
03F2  B1 26      LDA ($26),Y
03F4  91 28      STA ($28),Y
03F6  A2 46      LDX #$46
03F8  20 EE 02   JSR $02EE
03FB  A5 46      LDA $46
03FD  05 47      ORA $47
03FF  60         RTS
;--------------------------	;SCPU 0A XX,ZZ,ZZ AL=04; ADD 16bit ZZ=XX+YY
0400  20 A0 04   JSR $04A0
0403  AA         TAX
0404  B1 24      LDA ($24),Y
0406  A8         TAY
0407  18         CLC
0408  B9 00 00   LDA $0000,Y
040B  75 00      ADC $00,X
040D  85 E4      STA $E4
040F  B9 01 00   LDA $0001,Y
0412  75 01      ADC $01,X
0414  85 E5      STA $E5
0416  38         SEC
0417  B0 16      BCS $042F
;--------------------------	;SCPU 0B 0B XX,YY,ZZ AL=4; SUB 16bit ZZ=XX-YY
0419  20 A0 04   JSR $04A0
041C  AA         TAX
041D  B1 24      LDA ($24),Y
041F  A8         TAY
0420  38         SEC
0421  B5 00      LDA $00,X
0423  F9 00 00   SBC $0000,Y
0426  85 E4      STA $E4
0428  B5 01      LDA $01,X
042A  F9 01 00   SBC $0001,Y
042D  85 E5      STA $E5
042F  A0 03      LDY #$03
0431  B1 24      LDA ($24),Y
0433  AA         TAX
0434  A5 E4      LDA $E4
0436  95 00      STA $00,X
0438  A5 E5      LDA $E5
043A  95 01      STA $01,X
043C  4C CF 11   JMP $11CF		;PC SCPU INC
;--------------------------
043F  00         BRK
0440  86 28      STX $28	;SCPU 0C  AL=1; COMPRESS SOURCE CODE LINE
0442  86 0E      STX $0E
0444  86 27      STX $27
0446  86 26      STX $26
0448  A4 28      LDY $28
044A  B1 00      LDA ($00),Y
044C  C5 27      CMP $27
044E  D0 06      BNE $0456
0450  C6 26      DEC $26
0452  E6 28      INC $28
0454  D0 F2      BNE $0448
0456  AA         TAX
0457  A4 0E      LDY $0E
0459  A5 26      LDA $26
045B  F0 03      BEQ $0460
045D  91 00      STA ($00),Y
045F  C8         INY
0460  8A         TXA
0461  91 00      STA ($00),Y
0463  85 27      STA $27
0465  E6 28      INC $28
0467  C8         INY
0468  84 0E      STY $0E
046A  A2 00      LDX #$00
046C  C9 0D      CMP #$0D
046E  D0 D6      BNE $0446
0470  86 0F      STX $0F
0472  F0 49      BEQ $04BD
0474  AD 40 17   LDA $1740		;*** ? CASASM has JMP 1303 INPUT CHAR

0477  EA         NOP
0478  EA         NOP
0479  4C D3 13   JMP $13D3		;*** ???
;--------------------------  	;SCPU 0D,L AL=2; REL BRANCH
         		
047C  0A 10 12 10 ADD (0010,1)=(0010,1)+(0012,1)
0481  0A 14 42 14 ADD (0014,5)=(0014,5)+(0042,3)    
0484  03 2C 12 	  MOV $2C $12	     
0487  09 10 05 1A 03
		  BRA $03 =$048E
048C  12 01	  RTS,L
;-------------------------      
048E  8E 74 10 38 JSR ($079C)=$04C0   	     
0492  15 	  MC6502

0493  C8 	 INY    	
0494  B1 10      LDA ($10),Y
0496  C9 0D      CMP #$0D
0498  D0 F9      BNE $0493
049A  C8         INY
049B  84 12      STY $12
049D  6C A2 07   JMP ($07A2)		;not used by INIT,
;--------------------------
04A0  B1 24      LDA ($24),Y		;used by FUN 03,09,0A,0B,22
04A2  10 09      BPL $04AD		;look for next argument in PCode instruction
04A4  29 7F      AND #$7F		;if -ve use to index calling instruction
04A6  84 E4      STY $E4		;TEMP Y
04A8  A8         TAY
04A9  B1 FA      LDA ($FA),Y		;set @ 11BD
04AB  A4 E4      LDY $E4		;from TEMP Y
04AD  C8         INY
04AE  60         RTS
;--------------------------	;SCPU 22 AL=3
04AF  20 A0 04   JSR $04A0
04B2  AA         TAX
04B3  A1 00      LDA ($00,X)  
04B5  48         PHA
04B6  20 A0 04   JSR $04A0
04B9  AA         TAX
04BA  68         PLA
04BB  81 00      STA ($00,X)
04BD  4C CF 11   JMP $11CF		;PC SCPU INC
;--------------------------	;SCPU 0E ;MOV BLOCK Len XX start YY dest ZZ
04C0  03 81 46    MOV $81-$46    	;SCPU OP-CODE & DATA    
04C3  03 82 26    MOV $82-$26         
04C6  03 83 28    MOV $83-$28          
04C9  09 46 02 2C 19			;???
		 BRA $19 =$04E6
04CE  09 26 04 28 15
		 BRA $15 =$04E7
04D3  15 	 MC6502     
04D4  88         DEY
04D5  F0 07      BEQ $04DE
04D7  C8         INY
04D8  D0 04      BNE $04DE
04DA  E6 27      INC $27
04DC  E6 29      INC $29
04DE  20 F2 03   JSR $03F2
04E1  D0 F4      BNE $04D7
04E3  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code
;--------------------------
04E6  11	 RTS			;here from $04C9 ???
04E7  0A 46 26 26 ADD (0026,7)=(0046,7)+(0026,7)    		
04EB  0A 46 28 28 ADD (0028,9)=(0046,7)+(0028,9)              
04EF  15 	 MC6502
;--------------------------		;here on CR at EOL for source text entered
04F0  88         DEY
04F1  98         TYA
04F2  D0 04      BNE $04F8
04F4  C6 27      DEC $27
04F6  C6 29      DEC $29
04F8  88         DEY
04F9  20 F2 03   JSR $03F2
04FC  D0 F3      BNE $04F1
04FE  F0 E3      BEQ $04E3
;--------------------------	;SCPU 1B AL=2; PRINT LINE @ XX/XX+1 Decompress text
0500  B1 24      LDA ($24),Y		;$0024,5=
0502  AA         TAX
0503  B5 00      LDA $00,X
0505  85 26      STA $26
0507  B5 01      LDA $01,X
0509  85 27      STA $27
050B  88         DEY
050C  A2 FF      LDX #$FF
050E  B1 26      LDA ($26),Y		;$0026,7=
0510  10 03      BPL $0515
0512  AA         TAX
0513  A5 28      LDA $28		;($28)= ???
0515  20 43 03   JSR $0343		;Print (A)

0518  E8         INX
0519  30 FA      BMI $0515
051B  85 28      STA $28
051D  C8         INY
051E  C9 0D      CMP #$0D
0520  D0 EA      BNE $050C
0522  A9 00      LDA #$00		;PRINT NULL  after EOL CR
0524  20 3E 03   JSR $033E		;PRINT 'LF'
0527  4C CF 11   JMP $11CF		;PC SCPU INC
;--------------------------		;SUB called @ 05A5,03E6
052A  85 E4      STA $E4		;SAVE AXY
052C  86 E5      STX $E5
052E  84 E6      STY $E6
0530  A6 E6      LDX $E6
0532  A0 01      LDY #$01
0534  A5 01      LDA $01
0536  30 0B      BMI $0543
0538  C8         INY
0539  16 00      ASL $00,X
053B  36 01      ROL $01,X
053D  30 04      BMI $0543
053F  C0 11      CPY #$11
0541  D0 F5      BNE $0538		;LOOP
0543  84 E7      STY $E7		;TEMP Y
0545  A4 E4      LDY $E4
0547  A2 00      LDX #$00
0549  96 00      STX $00,Y
054B  96 01      STX $01,Y
054D  A4 E6      LDY $E6		;RESTORE y
054F  A6 E5      LDX $E5		;RESTORE X
0551  38         SEC
0552  B5 00      LDA $00,X
0554  F9 00 00   SBC $0000,Y
0557  85 EC      STA $EC		;TEMP A
0559  B5 01      LDA $01,X
055B  F9 01 00   SBC $0001,Y
055E  90 06      BCC $0566
0560  95 01      STA $01,X
0562  A5 EC      LDA $EC		;from TEMP
0564  95 00      STA $00,X
0566  A6 E4      LDX $E4
0568  36 00      ROL $00,X
056A  36 01      ROL $01,X
056C  C6 E7      DEC $E7		;COUNT TEMP Y
056E  F0 13      BEQ $0583
0570  A6 E6      LDX $E6		;RESTORE x
0572  56 01      LSR $01,X 
0574  B5 00      LDA $00,X
0576  90 05      BCC $057D
0578  4A         LSR A
0579  09 80      ORA #$80
057B  D0 01      BNE $057E
057D  4A         LSR A
057E  95 00      STA $00,X
0580  38         SEC
0581  B0 CC      BCS $054F
0583  A5 E4      LDA $E4		;RESTORE AX
0585  A6 E5      LDX $E5
0587  60         RTS
;--------------------------		;called @ 1363
0588  84 3F      STY $3F		;TEMP Y
058A  20 74 04   JSR $0474		;Do INPUT or OUTPUT @ 13D3
058D  A4 3F      LDY $3F		;RESTORE Y
058F  60         RTS
;--------------------------		;RENUMBER Function entry
0590  B1 24      LDA ($24),Y	;SCPU 19 XX AL=2
0592  AA         TAX			;? DEC digit in XX,XX+1,RJ in field of 5
0593  B5 00      LDA $00,X
0595  85 26      STA $26
0597  B5 01      LDA $01,X
0599  85 27      STA $27
059B  A9 05      LDA #$05
059D  85 46      STA $46		;$46=
059F  A2 26      LDX #$26
05A1  A0 3C      LDY #$3C
05A3  A9 28      LDA #$28
05A5  20 2A 05   JSR $052A
05A8  85 47      STA $47
05AA  B5 00      LDA $00,X
05AC  48         PHA
05AD  8A         TXA
05AE  A6 47      LDX $47
05B0  C6 46      DEC $46
05B2  D0 F1      BNE $05A5
05B4  A2 80      LDX #$80
05B6  68         PLA
05B7  F0 05      BEQ $05BE
05B9  AA         TAX
05BA  09 30      ORA #$30
05BC  D0 07      BNE $05C5
05BE  09 30      ORA #$30
05C0  E8         INX
05C1  10 02      BPL $05C5
05C3  A9 20      LDA #$20
05C5  20 43 03   JSR $0343		;Print (A) ' '
05C8  E6 46      INC $46
05CA  A5 46      LDA $46
05CC  C9 05      CMP #$05
05CE  D0 E6      BNE $05B6
05D0  4C CF 11   JMP $11CF		;PC SCPU INC
;--------------------------		;SCPU OP-CODE & DATA
05D3  09 36 02 2C 04   			;???  called @ 06D9
		 BRA $04 =$05DB
05D8  03 36 14 	 MOV $36-$14         
05DB  04 DC 06   JMP $06DC    
05DE  00      
05DF  00
;--------------------------        
05E0  8E 74 D4 32 JSR ($079C)=$04C0	;called @ 0C2D 
05E4  15 	  MC6502          
;--------------------------
05E5  A5 30      LDA $30
05E7  D0 0C      BNE $05F5
;--------------------------		
05E9  A5 6F      LDA $6F
05EB  A0 05      LDY #$05
05ED  91 0C      STA ($0C),Y
05EF  A9 FF      LDA #$FF
05F1  A0 03      LDY #$03
05F3  91 0C      STA ($0C),Y
05F5  4C AB 0B   JMP $0BAB
;--------------------------		;SCPU OP-CODE & DATA
05F8  03 5E 56   MOV $5E-$56    	;here from $0909  
05FB  13 00	 INC $00           
05FD  04 97 0A   JMP $0A97
;--------------------------		;SCPU PROGRAM -$077F        


0600  00  	 INPUT       
0601  96 61 14 1C JSR ($07AC)		;=JSR $0626
 	     		
   

0605  02 41 	 CMP #'A W/($00,6)     	;A ASM COMMAND?
0607  59 	 BEQ $0660
0608  02 49	 CMP #'I W/($00,6) 	;INIT ?
060A  69 	 BEQ $0673
060B  02 50	 CMP #'P W/($00,6)  	;PRINT ?    
060D  59      	 BEQ $0666
060E  02 44 	 CMP #'D W/($00,6)  	;DELETE ?   
0610  59 	 BEQ $0669
0611  02 52      CMP #'R W/($00,6)	;RENUMBER
0613  59 	 BEQ $066C
0614  04 8B 14	 JMP $148B	        ;*** CMD EXTENSIONS @$148B						   
0616  08 43 4D 44 20 45 52 52 0D 	;? "CMD ERR" 				
						   
0620  07 2E 00   PRINT '.'		;PROMPT '.'
0623  05 DC	 JMP $0600 		;ALWAYS		
0625  1F 	 NOP
;--------------------------		;SCPU 16
0626  03 00 04	 MOV $00-$04		
0629  14 00	 DEC $00
062B  13 00      INC $00
062D  01 20      CMP ($00,0) W/#$20	;SPACE?
062F  FC	 BEQ $0629		;IGNORE
0630  03 2C 08   MOV $2C-$08
0633  03 00 06	 MOV $00-$06        
0636  01 80 11	 CMP ($00,0) W/#$41     ;ALPHA?
		 BMI $0649
		 CMP ($00,0) W/#$58
		 BMI $0649		;YES ALPHA
0639  01 81 16   CMP ($00,0) W/#$30	;NUMERAL?
		 BMI $0651		;NO
		 CMP ($00,0) W/#$3A
		 BMI 			;YES NUMERAL
063C  01 0D 1C   CMP ($00,0) W/#$0D	;RETURN?   ???
		 BMI $065A
063F  03 00 06	 MOV $00-$06
0642  03 F0 08   MOV $F0-$08  
0645  13 00      INC $00
0647  12 02      RTS

0649  13 00      INC $00		;APLHA
064B  13 08      INC $08
064D  01 80 FA   CMP ($00,0) W/#$41
		 BMI $0649
		 CMP ($00,0) W/#$58
		 BMI $0649
0650  11         RTS

0651  13 00      INC $00		;NUMERIC
0653  13 08      INC $08
0655  01 81 FA   CMP ($00,0) W/#$30
		 BMI $0651
		 CMP ($00,0) W/#$3A
		 BMI $0651				 
0658  12 01      RTS
065A  12 03      
065C  24 0D 	 PRINT 'CR'     
065E  05 A2	 JMP $0601
;--------------------------		     
0660  04 56 11  JMP $1156    	;A A0 A1 A2 ASM CMDs

0663  04 90 06  JMP $0690
;--------------------------		    

0666  04 50 07  JMP $0750		;PRINT CMD
;--------------------------		     

0669  04 D0 07  JMP $07D0		;DEL CMD
;--------------------------		     

066C  04 2D 08  JMP $082D  		;RENUM CMD
;--------------------------
066F  15 	MC6502
0670  4C 1E 13  JMP $131E		;MON EXIT $FFFC	*** ???

;--------------------------		;I INIT CMD    
0673  07 0D  	PRINT			;? 'CR'
0675  07 	PRINT
0676  49 4E 49 5A 3F 00      		;? 'INIZ?       
067C  1F 	NOP        
067D  1F  	NOP       
067E  00 	INPUT        
067F  03 16 10	MOV $16-$10          
0682  03 2C 12 	MOV $2C-$12        
0685  01 59 	CMP #'Y'		;reply 'Y' to INIT   
	 03	BEQ $068A
0688  05 04	JMP $068D       
068A  03 16 1A  MOV $$16-$1A      
068D  04 20 06  JMP $0620     		;print'.' Go top SCPU CMD loop
			 

;--------------------------	;A CMD  ;SCPU OP-CODE & DATA 
0690  10 36 61			;INPUT decimal number in L,BRANCH H  =$06F3   				  
0693  0C				;Go SCPU 0C  $0440 -compress source line
0694  0A 0E 74 0E ADD (000E,F)=(000E,F)+(0074,5)      
0698  09 36 02 2C 15
		BRA $15 =$06B1
				   
069D  09 36 03 14 02
		BRA $02 =$10A3
06A2  8F	JSR ($079E)=$03D4         
				 
06A3  09 14 03 36 05
		BRA $05 =$10AC
06A8  8D 08	JSR ($079A)=$047C 
06AA  05 F8  	JMP $06A3        
					
06AC  09 14 02 36 04
		BRA $04 =$10B4
				   
06B1  03 2C 12  MOV $2C-$12  
06B4  0A 10 0E 1C ADD (001C,D)=(00010,1)+(000E,F) 
06B8  0A 10 12 1E ADD (001E,F)=(0010,1)+(0012,3)      
			  
				 
06BC  0B 1A 1E 20                
				 
		   
06C0  0A 1C 20 22    
				 
06C4  09 22 01 18 22
		 BRA $22 =$06E6      
06C9  8E 20 1E 1C JSR ($079C)=$04C0        
			  
	   
06CD  0B 0E 74 1C           
06D1  0A 10 74 1E ADD (001E,F)=(0010,1)+(0074,5)      
06D5  8E 1C 00 1E JSR ($079C)=$04C0
				 
 
06D9  04 D3 05    JMP $05D3
				  

06DC  8E 74 3A 10 JSR ($079C)=$04C0
06E0  03 0E 12  MOV $0E-$12   
06E3  03 22 1A  MOV $22-$1A
06E6  8D 01   
06E8  05 14 	JMP $06FD  
06EA  07        STROUT
06EB   2A 46 55 4C 4C 0D        	;'* FULL'      		       
;--------------------------
06F1  05 0B      JMP $06FD
06F3  08         STROUT			;'---^'

06F4   23 54 4F 4F 20        	    	;'# TOO 
06F9   42 49 47 0D 			; BIG' 
06FD  04 20 06	 JMP $0620		;
		
;--------------------------	;SCPU 1A
0700  03 2C 1C    MOV $2C-$1C  		;SCPU OP-CODE & DATA
0703  03 2E 1E	  MOV $2E-$1E			
0706  96 05 14 45 JSR ($07AC)=$0626    
				 
		 
070A  05 70	  JMP $077B
070C  10 1C 33    INPUT			;INPUT DEC $1C BPL $073F ??
070F  96 2B 10 06 JSR ($07AC)=$0626  
0713  03 1C 1E    MOV $1C-$1E
0716  97 	  JSR $02CB
0717  11	  RTS 
0718  03 1C 1E 	  MOV $1C-$1E
071B  11 	  RTS
071C  02 2D 0B    CMP #'- W/($00,6)
		 BEQ $0729     
071F  05 1B      JMP $073B
0721  02 2D 06   CMP #'- W/($00,6)
		 BEQ $0729 
0724  02 2C F2 	 CMP #',- W/($00,6)
		 BEQ $0717  
0727  05  13	 JMP $073B

0729  96 05 0D EB JSR ($07AC)=$0626
					  
		   
072D  05 E8 	 JMP $0716		;??          
072F  10 1E 10   INPUT			;INPUT DEC $1E BPL $073F ??
0732  96 08 04 E2 JSR ($07AC)=$0626          
			  
			
0736  05 DF 	 JMP $0716		;??   
0738  02 2C DD   CMP #',- W/($00,6)
		 BEQ $0717 
073B  08	 PRINT 			;'---^??'
073C  3F 3F 0D
073F  05 0B   	 JMP $074B
0741  08         STROUT			;?'---^'

0742   23 54 4F 4F 20 42 49 47 0D       ;'# TOO BIG' 
074B  1F 1F 1F   NOPS 
074E  12 01      RTS,L
;--------------------------	;P PRINT TEXT SOURCE CMD
0750  9A 01	 JSR ($07B4)=$0700         
0752  07 0D				;?CR
0754  8F	 JSR ($079E)=$03D4 
		 
0755  09 10 02 1A 1F
		 BRA $1F =$0778  
				  
075A  09 14 03 1C 05
		 BRA $05 =$0763            
075F  8D 08	 JSR ($079A)=$047C   	
		   
					  
0761  05 F8	 JMP $075A    
0763  09 14 06 1E 05
		 BRA $05 =$076C           
0768  9A 0F	 JSR ($07B4)=$0700               
			  
				 
076A  05 E9	 JMP $ 0754     
076C  19 14	 PRINT			;Print DEC ($14,5) RJ in FIELD 5
076E  0A 10 74 20 ADD (0020,1)=(0010,1)+(0074,5)  
0772  1B 20 				;Print line @ (0020)  
0774  8D F3 	 JSR ($079A)=$047C 
			  
	
0776  05 EC  	 JMP $0763 
0778  04 01 06   JMP $0601
077B  97	 JSR ($07AE)=$02CB      
077C  12 01      RTS,L
077E  FF         
077F  FF         
;--------------------------		;SCPU PROGRAM JUMP TABLE -07CF
					;$00E6 JMP Table lo,hi
0780  03 02        			;FUNC 00 ADD  ***    				


0782  40 02        			
0784  44 02      		        
0786  70 02      
0788  9C 02      
078A  84 02      
078C  63 02     
078E  7D 03       
0790  EC 03            
0792  A0 03      
0794  00 04      
0796  19 04     
0798  40 04   
079A  7C 04
079C  C0 04       
079E  D4 03
             
07A0  00 03 				;FUNC 10 ADD                
07A2  BC 02
07A4  B8 02  
07A6  D0 02     
07A8  DC 02      
07AA  E4 02      
07AC  26 06      
07AE  CB 02      
07B0  65 09      
07B2  90 05      
07B4  00 07      
07B6  00 05        
07B8  5D 09       
07BA  89 09      
07BC  85 09      
07BE  4E 02
      
07C0  30 0C 				;FUNC 20 ADD     
07C2  F0 0A     
07C4  AF 04   
07C6  60 0A        
07C8  80 03     
07CA  E5 0B        
07CC  C5 0B      
07CE  25 0E 				;FUNC 27 ADD    
   
;--------------------------	;D DELETE CMD
07D0  9A 36	 JSR ($07B4)=$0700         
		 
07D2  03 2C 22 	 MOV   
07D5  05 04	 JMP $07DA
07D7  04 01 06   JMP $0601  
07DA  8F	 JSR ($079E)=$03D4         
07DB  09 14 03 1C 05
		 BRA $05 =$07E4 	    
07E0  8D 30 	 JSR ($079A)=$047C   
07E2  05 F8	 JMP $07DB    		       
						  
					
07E4  03 10 1C   MOV 10 1C
						  
07E7  09 14 01 1E 05		
		 BRA $05 =$07F0      
07EC  13 22      INC $22
07EE  05 36    	 JMP $0825
07F0  0B 1A 20 1E SUB (001E,F)=(001A,B)-(0020,1)    
07F4  09 22 02 2C 19
		 BRA $19 =$0811
07F9  8E 1E 20 1C JSR ($079C)=$04C0
07FD  0A 1C 1E 1A ADD (001A,B)=(001C,D)+(001E,F)   
0801  8F	 JSR ($079E)=$03D4         
0802  9A D4	 JSR ($07B4)=$0700         
0804  05 CD 	 JMP $07D2
					  
					 
0805  FF				
0806  08 	 	 STROUT  

0808   4C 49 4E 45 53 3F 0D		;'LINES ?'         
080F  05 12      JMP $0822
0811  08  	 STROUT       

0812  4E 4F 20   			;'NO SUCH LINE(S)'
0815  53 55 43 48                
0819  20 4C 49 4E 45 28 53 29 0D       

0822  04 20 06   JMP $0620
;--------------------------		;SCPU OP-CODE & DATA
0825  0A 10 12 20 ADD (0020,1)=(0010,1)+(0012,3)          
0829  8D C6	  JSR ($079A)=$047C    
						  
082B  05 BB 	  JMP $07E7    
;--------------------------	;R RENUMBER CMD
082D  03 3C 36	 MOV $3C $36        
082F  8F  	 JSR ($079E)=$03D4
0831  09 10 02 1A 0D
		 BRA $0D =$0842
0836  8E 74 3A 10 JSR ($079C)=$04C0
083A  0A 3C 36 36 ADD (0036,7)=(003C,D)+(0036.7)     
083E  8D 03	  JSR ($079A)=$047C
0840  05 F0	 JMP $0831  
0842  07 00 	 STROUT			;Print null             
0844  8F	 JSR  ($079E)=$03D4       
0845  19 36 	 PRINT			;Print DEC ($36,7) RJ in FIELD 5
							
0847  04 5C 06   JMP $065C		;Prints 'CR .' and Go CMD enrty
;--------------------------
084A  04 4A 11   JMP $114A   
084D  04 00 10   JMP $1000 
;--------------------------		;from $112D ASM
0850  03 2C 7C   MOV $2C-$7C 
0853  03 18 0A   MOV $18-$0A		;clear label table.see notes on linking SYMBOL TBL. LOCN 0855=0A/0B
0856  03 42 40   MOV $42-$40    
0859  04 7A 14   JMP $147A		;***    

085C  8F	 JSR ($079E)=$03D4 	;here for A2 CMD  
		   
085D  03 2C F0   MOV $2C-$F0      
0860  03 2C E2   MOV $2C-$E2
0863  23   				;DECOMPRESS SOURCE @ ($10),Y 
0864  03 02 00   MOV $02-$00 		;move pointer for line of text    
0867  03 4A 4C   MOV $4A-$4C
086A  03 4E 50   MOV $4E-$50
086D  03 4E 52   MOV $4E-$52
0870  03 2C 54	 MOV $2C-$54 
0873  9C	 JSR ($07B8)=$095D   
0874  01 0D 	 CMP $0D		; CR ?
	 50   	 BEQ $08C6
0877  01 3B 	 CMP #';		; ; ? comment
	 34  	 BEQ $08AD 
087A  01 2A 	 CMP #'*		; * ? program counter
	 D1      BEQ $0756    

087D  01 2E 	 CMP #'.		; . ?
	 CB      BEQ $084A		;process directive
0880  A1	 JSR ($07C2)=$0AF0   
0881  06 1F 18   STROUT			;---^,STRING,00/0D ??        
					
0884  09 05 6E 9D 23
		 BRA $23 =$08AB				 
0889  03 31 01   MOV $41-$01
088C  03 42 54	 MOV $42-$54
088F  01 20      CMP $20
0891     03      BEQ $0894 		; 
0892  05 07      JMP $089A
0894  9C	 JSR ($07B8)=$095D
0985  A1	 JSR ($07C2)=$0AF0 
0896  1C 	 SKS			;skip spaces
0897  01 2E  	 CMP #'.		; . ?
0899  B1      	 BEQ $084A
089A  01 2A      CMP #'*		; * ?
089C     B1 	 BEQ $084D
089D  01 3D	 CMP #'=		; = ?    
	 09 	 BEQ $08A8
08A0  01 3B      CMP #';		; ; ?
	 0A 	 BEQ $08AC		;???
08A3  01 0D      CMP $0D
	 08 	 BEQ $08AD
08A6  05 10      JMP $08B7
08A8  04 28 10   JMP $1028
08AB  18 01      			;get ERR# XX and txt ptr
08AD  03 2C 4C	 MOV $2C-$4C      
08B0  05 43	 JMP $08F4          
08B2  9E 04 03 06 01 JSR ($07BC)=$0985  ;???
08B7  18 06	 ERR 			;get ERR# XX and txt ptr    
08B9  05 3A	 JMP $08F4             
									
08BB  01 83	 CMP #$83      
08BD  03	 BEQ $08C0		;CTRL CHAR         
08BE  05 F8 	 JMP $08B7    
08C0  04 B4 0E   JMP $0EB4
08C3  2C 	 BRK
08C4  30	 BRK   
08C5  9C	 JSR ($07B8)=$095D 	;called $0EB9
08C6  01 0D 	 CMP #$0D  
08C8  44 	 BEQ $090C
08C9  01 23	 CMP #'# 		; # ?            
08CB  14 	 BEQ $08DF
08CC  01 28	 CMP #'( 		; ( ?             
08CE  28         BEQ $08F6
08CF  03 58 56	 MOV $58 $56                 
08D2  01 41	 CMP #'A 		; A ?    
08D4  7C	 BEQ $0950      
08D5  A0 1E 	 JSR ($07C0)=$0C30 
						 
08D7  01 2C 5B   CMP ($00,0) W/#',	; , ?  
08DA  03 5A 56   MOV $5A-$56           
08DD  05 6A	 JMP $0948           
									  
08DF  13 00	 INC $00               
08E1  A0 12	 JSR ($07C0)=$0C30 
						 
08E3  01 83 05	 CMP ($00,0) W/#'	;???
		 BEQ $08EA
08E6  18 07	 ERR			;get ERR# and txt ptr JMP from 0A9A 
										   
08E8  05 0B	 JMP $08F4     
08EA  03 5C	 MOV $5C $56 
08EC  56 14				;***
08EE  4C 1F 05   JMP $1F05		;***

08F1  5C 18 14   JMP $1418
08F4  05 65      JMP $095A
08F6  13 00	 INC $00
08F8  A0 61	 JSR ($07C0)=$0C30     
08FA  01 2C	 CMP #',		; , ?     
08FC  06 	 BEQ $0904
08FD  01 29	 CMP #')      		; ) ?
08FF  21 	 BEQ $0922   
0900  05 E5      JMP $08E6
0902  13 00      INC $00
0904  01 58      CMP #'X		; X ?
0906     03      BEQ $0909 
0907  05 DE      JMP $08E6
0909  04 F8 05   JMP $05F8
090C  18 OF      ERR       
				 
090E  05 4B      JMP $095A
		
0910  13 00      INC $00 		;JMP from 0A9D
0912  01 83      CMP $83
0914     03      BEQ $0917
0915  05 D0      JMP $08E6
0917  09 6A 04 41 32
		 BRA $32 =$094D		;???          
091C  18 0D      ERR
				 		 
091E  05 3B   	 JMP $095A
0920  13 00      INC $00
0922  01 2C      CMP #',		; , ?
0924     06 	 BEQ $092A 
0925  03 62 56   MOV $62-$56  
0928  05 1F      JMP $0948
092A  13 00      INC $00
092C  03 60 56   MOV $40-$56   
092F  01 59      CMP #'Y		; Y ?		
0930     DF 	 BEQ $0910
0932  05 B3  	 JMP $08E6
0934  13 00      INC $00
0936  03 64 56   MOV $64-$56
0939  01 58      CMP #'X		; X ?
093B     0B      BEQ $0946
093C  03 66 56   MOV $66-$56
093F  01 59      CMP #'Y		; Y ?
0941     05      BEQ $0946
0942  18 08	 ERR
0944  05 15 	 JMP $095A
0946  13 00	 INC $00		        
0948  01 83      CMP $83
094A     03      BEQ $094D
094B  05 9A      JMP $08E6

094D  04 3D 0D   JMP $0D3D
0950  13 00   	 INC $00
0952  01 83      CMP $83
0954     F9 	 BEQ $094D
0955  14 00      DEC $00
0957  04 D5 08   JMP $08D5
095A  04 AA 10   JMP $10AA
---------------------------
095D  14 00	 DEC $00     	;SCPU 1C;SKIP SPACES
095F  13 00      INC $00
0961  01 20 	 CMP $20		;" " ?
	 FC	 BEQ $095F
0964  11   	 RTS
;--------------------------
0965  A6 E2      LDX $E2	;SCPU 18
0967  E0 04      CPX #$04
0969  F0 17      BEQ $0982
096B  B1 24      LDA ($24),Y
096D  0A         ASL A
096E  A4 40      LDY $40
0970  88         DEY
0971  D0 02      BNE $0975
0973  90 0D      BCC $0982
0975  4A         LSR A
0976  9D F6 00   STA $00F6,X
0979  E8         INX
097A  A5 00      LDA $00
097C  9D F6 00   STA $00F6,X
097F  E8         INX
0980  86 E2      STX $E2
0982  4C CF 11   JMP $11CF		;PC SCPU INC		
;--------------------------	;SCPU 1E
0985  15 	 MC6502
0986  88         DEY
0987  F0 01      BEQ $098A

0989  15 	 MC6502		;SCPU 1D
098A  4C ED 0B   JMP $0BED
098D  6E
;-------------------------- 		;called @ 0BF3
098E  05 6F      ORA $6F     
0990  D0 27      BNE $09B9
0992  A9 40      LDA #$40
0994  85 E4      STA $E4
0996  0A         ASL A
0997  AA         TAX
0998  BC 01 0F   LDY $0F01,X		;6502 OP CODE table
099B  C4 6D      CPY $6D
099D  90 0F      BCC $09AE
099F  D0 09      BNE $09AA
09A1  BC 00 0F   LDY $0F00,X		;6502 OP CODE table
09A4  C4 6C      CPY $6C
09A6  90 06      BCC $09AE
09A8  F0 76      BEQ $0A20
09AA  E5 E4      SBC $E4
09AC  B0 02      BCS $09B0
09AE  65 E4      ADC $E4
09B0  46 E4      LSR $E4
09B2  A4 E4      LDY $E4
09B4  C0 02      CPY #$02
09B6  10 DF      BPL $0997
09B8  EA         NOP
09B9  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
09BC  0B 18 F2 0C SUB (000C,D)=(0018,9)-(00F2,3)             			 
09C0  15 	 MC6502
;--------------------------		
09C1  A5 0C	 LDA $0C   
09C3  38    	 SEC
09C4  E5 0A      SBC $0A
09C6  A5 0D      LDA $0D
09C8  E5 0B      SBC $0B
09CA  90 75      BCC $0A41
09CC  A5 6D      LDA $6D
09CE  D1 0C      CMP ($0C),Y
09D0  D0 21      BNE $09F3
09D2  A5 6C      LDA $6C
09D4  C1 0C      CMP ($0C,X)
09D6  D0 1B      BNE $09F3
09D8  A0 03      LDY #$03
09DA  B1 0C      LDA ($0C),Y
09DC  C9 FE      CMP #$FE
09DE  90 08      BCC $09E8
09E0  85 32      STA $32
09E2  A0 05      LDY #$05
09E4  B1 0C      LDA ($0C),Y
09E6  A0 03      LDY #$03
09E8  C5 6F      CMP $6F
09EA  D0 07      BNE $09F3
09EC  88         DEY
09ED  A5 6E      LDA $6E
09EF  D1 0C      CMP ($0C),Y
09F1  F0 0F      BEQ $0A02
09F3  20 DC 11   JSR $11DC		;return to SCPU Execution mode
;--------------------------		;SCPU OP-CODE & DATA
09F6  0B 0C F4 0C SUB (000C.D=(000C,D)-(00F4,5)           	   
09FA  15 	 MC6502		
09FB  86 32	 STX $32    
								 
09FD  D0 C2      BNE $09C1
09FF  4C AB 0B   JMP $0BAB
0A02  A5 32      LDA $32
0A04  D0 41      BNE $0A47
0A06  A5 30      LDA $30
0A08  F0 3A      BEQ $0A44
0A0A  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
0A0D  0A 0C EA 0C ADD (000C,D)=(000C,D)+(00EA,B)          
		   
0A11  04 3C 11   JMP $113C 
    
0A14  8E 74 0C 78 JSR ($079C)=$04C0	;from $1144 ASM             
0A18  09 44 02 7E 03 			;???         
		 BRA $03 =$0A1F			
0A1D  18 0C      ERR		
0A1F  11	 RTS
;--------------------------		
0A20  BD 03 0F   LDA $0F03,X		;6502 OP CODE table
0A23  C9 FF      CMP #$FF
0A25  D0 05      BNE $0A2C
0A27  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
0A2A  12 01	 RTS,L

;--------------------------
0A2C  A8         TAY
0A2D  B9 D5 0D   LDA $0DD5,Y		;
0A30  85 1E      STA $1E
0A32  B9 E3 0D   LDA $0DE3,Y		;
0A35  85 1F      STA $1F
0A37  BD 02 0F   LDA $0F02,X		;6502 OP CODE table
0A3A  85 20      STA $20
0A3C  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		

;--------------------------		;SCPU OP-CODE & DATA
0A3F  12 03      RTS,L
;--------------------------		

0A41  4C 0C 0C   JMP $0C00
;--------------------------
0A44  4C 00 0C   JMP $0C00
;--------------------------
0A47  A0 04      LDY #$04
0A49  A6 30      LDX $30
0A4B  F0 03      BEQ $0A50
0A4D  4C 00 12   JMP $1200
;--------------------------
0A50  49 FE      EOR #$FE
0A52  D0 AB      BNE $09FF
0A54  85 7F      STA $7F
0A56  B1 0C      LDA ($0C),Y
0A58  85 7E      STA $7E
0A5A  A5 ED      LDA $ED
0A5C  4C E9 0A   JMP $0AE9
;--------------------------
0A5F  00         BRK
0A60  86 E4      STX $E4	;SCPU 23 AL=1
0A62  C8         INY
0A63  A2 FF      LDX #$FF
0A65  B1 10      LDA ($10),Y		; DECOMPRESS SOURCE @ ($10),Y
0A67  10 03      BPL $0A6C
0A69  AA         TAX
0A6A  A5 28      LDA $28
0A6C  84 E5      STY $E5
0A6E  A4 E4      LDY $E4
0A70  91 02      STA ($02),Y		; STORE @ ($02),Y
0A72  C8         INY
0A73  E8         INX
0A74  30 FA      BMI $0A70
0A76  85 28      STA $28
0A78  84 E4      STY $E4
0A7A  A4 E5      LDY $E5
0A7C  C8         INY
0A7D  C9 0D      CMP #$0D
0A7F  D0 E2      BNE $0A63
0A81  4C CF 11   JMP $11CF		;PC SCPU INC		
;--------------------------
0A84  86 E5      STX $E5
0A86  AA         TAX
0A87  B5 00      LDA $00,X
0A89  85 E8      STA $E8
0A8B  B5 01      LDA $01,X
0A8D  4A         LSR A
0A8E  85 E9      STA $E9
0A90  A9 10      LDA #$10
0A92  85 E6      STA $E6
0A94  18         CLC
0A95  90 2D      BCC $0AC4
;--------------------------		;SCPU OP-CODE & DATA
0A97  01 29 04   CMP #')'		;here from $05FD
		 BEQ $0A9D   
0A9A  04 E6 08   JMP $08E6        
0A9D  04 10 09   JMP $0910 
;--------------------------		
0AA0  A5 EC      LDA $EC
0AA2  90 0D      BCC $0AB1
0AA4  18         CLC
0AA5  A5 E7      LDA $E7
0AA7  79 00 00   ADC $0000,Y
0AAA  85 E7      STA $E7
0AAC  A5 EC      LDA $EC
0AAE  79 01 00   ADC $0001,Y
0AB1  20 E0 0A   JSR $0AE0
0AB4  85 EC      STA $EC
0AB6  A5 E7      LDA $E7
0AB8  20 E0 0A   JSR $0AE0
0ABB  85 E7      STA $E7
0ABD  A5 E9      LDA $E9
0ABF  20 E0 0A   JSR $0AE0
0AC2  85 E9      STA $E9
0AC4  A5 E8      LDA $E8
0AC6  20 E0 0A   JSR $0AE0
0AC9  85 E8      STA $E8
0ACB  C6 E6      DEC $E6
0ACD  10 D1      BPL $0AA0
0ACF  A6 E5      LDX $E5
0AD1  95 00      STA $00,X
0AD3  A5 E9      LDA $E9
0AD5  95 01      STA $01,X
0AD7  A5 E7      LDA $E7
0AD9  18         CLC
0ADA  05 EC      ORA $EC
0ADC  F0 01      BEQ $0ADF
0ADE  38         SEC
0ADF  60         RTS

0AE0  90 05      BCC $0AE7
0AE2  4A         LSR A
0AE3  09 80      ORA #$80
0AE5  D0 01      BNE $0AE8
0AE7  4A         LSR A
0AE8  60         RTS

0AE9  09 40      ORA #$40		;called @ 0A5C
0AEB  85 ED      STA $ED
0AED  6C A2 07   JMP ($07A2)		;
;--------------------------	;SCPU 21
0AF0  15 	 MC6502 
0AF1  8A	 TXA
0AF2  A2 04      LDX #$04
0AF4  95 6B      STA $6B,X
0AF6  CA         DEX
0AF7  D0 FB      BNE $0AF4
0AF9  85 26      STA $26
0AFB  85 27      STA $27
0AFD  85 29      STA $29
0AFF  84 47      STY $47
0B01  C8         INY
0B02  84 46      STY $46
0B04  D0 02      BNE $0B08
0B06  A2 04      LDX #$04
0B08  A0 00      LDY #$00
0B0A  B1 00      LDA ($00),Y
0B0C  DD 80 0B   CMP $0B80,X		;
0B0F  30 03      BMI $0B14
0B11  4C 93 0B   JMP $0B93

0B14  CA         DEX
0B15  10 F5      BPL $0B0C
0B17  A5 27      LDA $27
0B19  F0 60      BEQ $0B7B
0B1B  D0 4E      BNE $0B6B
0B1D  A4 27      LDY $27
0B1F  C0 06      CPY #$06
0B21  10 3E      BPL $0B61
0B23  38         SEC
0B24  E5 28      SBC $28
0B26  85 28      STA $28
0B28  A2 6C      LDX #$6C
0B2A  A4 47      LDY $47
0B2C  D0 02      BNE $0B30
0B2E  A2 6E      LDX #$6E
0B30  A4 46      LDY $46
0B32  D0 14      BNE $0B48
0B34  18         CLC
0B35  EA         NOP
0B36  75 00      ADC $00,X
0B38  95 00      STA $00,X
0B3A  A9 00      LDA #$00
0B3C  75 01      ADC $01,X
0B3E  95 01      STA $01,X
0B40  C6 47      DEC $47
0B42  A9 02      LDA #$02
0B44  85 46      STA $46
0B46  D0 19      BNE $0B61
0B48  B5 00      LDA $00,X
0B4A  85 E7      STA $E7
0B4C  B5 01      LDA $01,X
0B4E  85 EC      STA $EC
0B50  B9 8E 0B   LDA $0B8E,Y		;
0B53  85 E8      STA $E8
0B55  4C A3 0B   JMP $0BA3

0B58  A9 E8      LDA #$E8
0B5A  A0 28      LDY #$28
0B5C  20 84 0A   JSR $0A84
0B5F  C6 46      DEC $46
0B61  E6 00      INC $00
0B63  D0 02      BNE $0B67
0B65  E6 01      INC $01
0B67  E6 27      INC $27
0B69  D0 9B      BNE $0B06
0B6B  C9 07      CMP #$07
0B6D  10 05      BPL $0B74
0B6F  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
0B72  12 01      RTS,L


0B74  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------
0B77  18 0A 	 ERR	               
					  
0B79  12 01	 RTS,L
;--------------------------     

0B7B  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------
0B7E  11 FF
      
0B80  41 30				;A 0      
0B82  20 2E 24 				;. $ 
0B85  5B 				;[        
0B86  3B				;:         
0B87  20 2F 25 				;/ % 
0B8A  40 				;@        
0B8B  15 20      
0B8D  08				;        
0B8E  FD 28 
0B90  40				;				  
0B91  00         	
0B92  06
;-------------------------
0B93  DD 85 0B   CMP $0B85,X
0B96  30 03      BMI $0B9B
0B98  4C 14 0B   JMP $0B14
;--------------------------
0B9B  BC 8A 0B   LDY $0B8A,X
0B9E  84 28      STY $28		;$28=
0BA0  4C 1D 0B   JMP $0B1D
;--------------------------
0BA3  B9 90 0B   LDA $0B90,Y
0BA6  85 E9      STA $E9		;$E9=
0BA8  4C 58 0B   JMP $0B58
;--------------------------
0BAB  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;-------------------------		;called @ 0515, 0C10
0BAE  12 04      RTS,L
;--------------------------		;HEX to 2 digit ASCII and PRINT		

0BB0  B5 00      LDA $00,X		;called @ 0BE8 1113 125A
0BB2  84 3F      STY $3F
0BB4  48         PHA
0BB5  4A         LSR A
0BB6  4A         LSR A
0BB7  4A         LSR A
0BB8  4A         LSR A
0BB9  20 9B 2D   JSR $2D9B		;PRT2HEX
0BBC  68         PLA
0BBD  29 0F      AND #$0F
0BBF  20 9B 2D   JSR $2D9B		;PRT2HEX
0BC2  4C FC 02   JMP $02FC		;restore Y and return

0BC5  B1 24      LDA ($24),Y
0BC7  A8         TAY
0BC8  96 01      STX $01,Y
0BCA  A6 E2      LDX $E2
0BCC  F0 12      BEQ $0BE0
0BCE  CA         DEX
0BCF  BD F6 00   LDA $00F6,X
0BD2  85 06      STA $06
0BD4  CA         DEX
0BD5  BD F6 00   LDA $00F6,X
0BD8  99 00 00   STA $0000,Y
0BDB  86 E2      STX $E2
0BDD  4C CF 11   JMP $11CF		;Advance PC and execute

0BE0  A0 02      LDY #$02
0BE2  4C 84 02   JMP $0284
;--------------------------	;SCPU 25
0BE5  B1 24      LDA ($24),Y
0BE7  AA         TAX
0BE8  20 B0 0B   JSR $0BB0	;PRINT (XX) AS 2 DIGIT
0BEB  50 F0      BVC $0BDD
0BED  84 30      STY $30
0BEF  86 32      STX $32
0BF1  A5 6E      LDA $6E
0BF3  4C 8E 09   JMP $098E
;--------------------------
0BF6  50 06      BVC $0BFE
0BF8  EA         NOP
0BF9  20 33 13   JSR $1333		;PRINT via OUTVEC
0BFC  A4 3F      LDY $3F		;resore Y
0BFE  68         PLA
0BFF  60         RTS
;--------------------------
0C00  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
0C03  0A 0C EA 0C ADD (000C,D)=(000C,D)+(00EA,B)          
0C07  8E 74 0C 78 JSR ($079C)=$04C0        
					
0C0B  11	  RTS (RETURN)
;--------------------------		
0C0C  A5 7C      LDA $7C		;called @ 0A41
0C0E  F0 03      BNE $0C13
0C10  4C AB 0B   JMP $0BAB																		

0C13  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA

														  
0C16  09 0C 03 1A 08
		 BRA $08 =$0C22  			            
				
0C1B  18 99 	 ERR       
0C1D  03 42 7C	 MOV $42-$7C   
						
0C20  12 04	 RTS
   
0C22  03 OC 0A 	 MOV $0C-0A        
0C25  8E EA 7A 0C JSR ($079C)=$04C0         
0C29  0A 0C EA 32 ADD (0032,3)=(000C,D)+(00EA,B) 
0C2D  04 E0 05   JMP $05E0
;-------------------------    
0C30  03 2C EC	 MOV $2C-$EC	;SCPU 20         
0C33  03 2C 36   MOV $2C-$36
0C36  03 2C 6A 	 MOV $2C-$6A
0C39  01 83 	 CMP
	 79	 BEQ $0CB4            
0C3C  A1 20	 JSR ($07C2)=$0AF0
0C3E  0A 3C F4 34 ADD (0034,5)=(003C,D)+(00F4,5)   
						  
0C42  01 24      CMP #'$  		; $ ?
	 20	 BEQ $0C64 
0C45  0A 4A F2 34 ADD (0034,5)=(004A,B)+(00F2,3)     
0C49  01 40 	 CMP #'@		; @ ?
         19	 BEQ $0C64	     
0C4C  03 74 34 	 MOV $74-$34
0C4F  01 25	 CMP #'%		; % ?
         13 	 BEQ $0C64  
0C52  01 27	 CMP #''		; ' ? 
         69	 BEQ $0CBD     
0C55  04 F1 0E   JMP $0EF1           
0C58  03 3C 34	 MOV $3C-$34        
0C5B  05 0A 	 JMP $0C66           
0C5D  9E 78 77 76 75 JSR ($07BC)=$0985     
						  						  
0C62  05 79	 JMP $0CDC    
0C64  13 00	 INC $00         
0C66  03 2C 7E	 MOV $2C-$7E        
0C69  03 2C 6C	 MOV $2C-6C
0C6C  15 	 MC6502			;GO MC   

0C6D  A0 00      LDY #$00
0C6F  4C CC 0E   JMP $0ECC

0C72  30 2E      BMI $0CA2		;called @ 0ED3
0C74  C5 34      CMP $34
0C76  10 1D      BPL $0C95
0C78  E6 6C      INC $6C
0C7A  85 E7      STA $E7
0C7C  A9 00      LDA #$00
0C7E  85 EC      STA $EC
0C80  A2 7E      LDX #$7E
0C82  A0 7E      LDY #$7E
0C84  A9 34      LDA #$34
0C86  20 84 0A   JSR $0A84
0C89  90 02      BCC $0C8D
0C8B  E6 6D      INC $6D
0C8D  E6 00      INC $00
0C8F  D0 02      BNE $0C93
0C91  E6 01      INC $01
0C93  D0 D8      BNE $0C6D
0C95  E0 10      CPX #$10
0C97  D0 09      BNE $0CA2
0C99  38         SEC
0C9A  E9 07      SBC #$07
0C9C  30 04      BMI $0CA2
0C9E  C9 10      CMP #$10
0CA0  30 D6      BMI $0C78
0CA2  A5 6C      LDA $6C
0CA4  F0 0B      BEQ $0CB1
0CA6  A5 6D      LDA $6D
0CA8  F0 0E      BEQ $0CB8
0CAA  20 DC 11   JSR $11DC		;return to SCPU Execution mode				 

0CAD  18         CLC
0CAE  03         ERR				

0CAF  05 2C      ORA $2C
0CB1  20 DC 11   JSR $11DC		;return to SCPU Execution mode

0CB4  18         CLC
0CB5  07         ERR
0CB6  12 01      ERR #$01


0CB8  20 DC 11   JSR $11DC		;return to SCPU Execution mode

0CBB  05 20      ORA $20
0CBD  13         ERR
0CBE  00         BRK
0CBF  03         ERR



0CC0  2C 7E 22   BIT $227E
0CC3  00         BRK
0CC4  78         SEI
0CC5  04 DE 0E   JMP $0EDE     
0CC8  13 00	 INC $00   

0CCA  A1 01				;??     
0CCC  09 6E 05 2C E4 
		 BRA $E4 =$0CB4     	
0CD1  03 6C 7E 	 MOV $6E $7C      
0CD4  05 07	 JMP $0CDC        
0CD6  0A 42 ED ED ADD (00ED,E)=(0042,3)+(00ED,E)       
0CDA  05 5C 	 JMP $0D37
    
0CDC  03 3A 06	 MOV $3A $06         
OCDF  02 2F 	 CMP #'/		; / ? 
	 26	 BEQ $0D07            
0CE2  02 2A      CMP #'*		; * ?
         10	 BEQ $0CF4
0CE5  02 2D      CMP #'-		; - ?
         07	 BEQ $0CEE
0CE8  0A 6A 7E 6A ADD (006A,B)=(006A,B)+(007E,F)
0CEC  05 24	 JMP $0D11
0CEE  0B 6A 7E 6A SUB (006A,B)=(006A,B)-(007E,F)    
0CF2  05 1E	 JMP $0D11

0CF4  15 	 MC6502
 
0CF5  A9 6A	 LDA #$6A
0CF7  A0 7E      LDY #$7E
0CF9  86 E7      STX $E7
0CFB  86 EC      STX $EC
0CFD  A2 6A      LDX #$6A
0CFF  20 84 0A   JSR $0A84					   

0D02  20 DC 11   JSR $11DC		;return to SCPU Execution mode
0D05  05 0B      JMP $0D11
0D07  15 	 	 MC6502		;GO MC	
0D08  B6 6A      LDX #$6A,Y
0D0A  96 26      STX $26,Y
0D0C  88         DEY
0D0D  10 F9      BPL $0D08
0D0F  30 20      BMI $0D31
;--------------------------		;SCPU OP-CODE & DATA
0D11  01 2B 	 CMP #$2B
         0C	 BEQ $0D1F    
0D14  01 2D	 CMP #$2D   
         09	 BEQ $0D1F
0D17  01 2A	 CMP #$2A 
         06 	 BEQ $0D1F
0D1A  01 2F	 CMP #$2F    		      
         03	 BEQ $0D1F

0D1D  05 09   	 JMP $0D27              
0D1F  22 00 3A   			;???            
					
0D22  13 00	 INC $00                 
					
0D24  04 39 0C	 JMP $0C39      
0D27  09 6A 04 41 05
		 BRA $05 =$0D30			   
0D2C  0A 58 ED ED ADD (00ED,F)=(0058,9)+(00ED,E)
0D30  11   	 	 RTS
;--------------------
0D31  4C E0 03   JMP $03E0
;--------------------------
0D34  4C 06 0E   JMP $0E06
;--------------------------		;SCPU OP-CODE & DATA
0D37  18 12      ERR    
0D39  05 D7      JMP $0D11				
0D3B  00         
0D3C  00         
0D3D  15 	 MC6502
;--------------------------
0D3E  A0 FF      LDY #$FF
0D40  A5 1F      LDA $1F
0D42  25 57      AND $57		;$56,$57
0D44  D0 09      BNE $0D4F
0D46  A0 07      LDY #$07
0D48  A5 1E      LDA $1E
0D4A  EA         NOP
0D4B  25 56      AND $56
0D4D  F0 E5      BEQ $0D34
0D4F  2A         ROL A
0D50  C8         INY
0D51  90 FC      BCC $0D4F
0D53  C0 08      CPY #$08
0D55  10 5A      BPL $0DB1
0D57  B9 FD 0D   LDA $0DFD,Y		;$0DFD TBL
0D5A  2D 05 0E   AND $0E05		;???
0D5D  D0 31      BNE $0D90
0D5F  98         TYA
0D60  D0 4F      BNE $0DB1
0D62  A9 3F      LDA #$3F
0D64  24 ED      BIT $ED
0D66  D0 49      BNE $0DB1
0D68  EA         NOP
0D69  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
0D6C  0B 6A 44 6A SUB (006A,B)=(006A,B)-(0044,5)        
0D70  0B 6A 74 6A SUB (006A,B)=(006A,B)-(0074,5)          
0D74  09 6A 04 58 14
		 BRA $14 =$0D8C         
0D79  0A 6A 58 1C ADD (001C,D)=(006A,B)+(0058,9)    
0D7D  09 1C 04 58 0B
		 BRA $0B =$0D8C
0D82  05 04    
0D84  04 AA 10   JMP $10AA
0D86  04 2B 14	 JMP $142B
0D8A  1F     			 
0D8B  1F        
0D8C  15 	 MC6502 

0D8D  38  	 SEC
0D8E  B0 20      BCS $0DB0
0D90  A5 ED      LDA $ED
0D92  0A         ASL A
0D93  D0 11      BNE $0DA6
0D95  90 1A      BCC $0DB1
0D97  C8         INY
0D98  B9 FD 0D   LDA $0DFD,Y		;$0DFD TBL
0D9B  25 1F      AND $1F
0D9D  D0 12      BNE $0DB1
0D9F  20 DC 11   JSR $11DC		;return to SCPU Execution mode

0DA2  18 03      ERR  
0DA3  03 05 DF	 MOV $05 $DF        
;--------------------------		;
0DA6  C8         INY
0DA7  B9 FD 0D   LDA $0DFD,Y		;$0DFD TBL
0DAA  84 1E      STY $1E		;$1E=
0DAC  25 1F      AND $1F		;$1F=
0DAE  D0 1E      BNE $0DCE
0DB0  88         DEY
0DB1  A5 20      LDA $20
0DB3  4A         LSR A
0DB4  B9 0D 0E   LDA $0E0D,Y		;$0E0D TBL
0DB7  B0 03      BCS $0DBC
0DB9  B9 19 0E   LDA $0E19,Y		;$0E19 TBL
0DBC  18         CLC
0DBD  65 20      ADC $20
0DBF  85 50      STA $50		;$50=
0DC1  B9 F1 0D   LDA $0DF1,Y		;0DF1 TBL
0DC4  85 4C      STA $4C		;$4C=
0DC6  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
0DC9  03 6A 51   mov $6A-$51           
0DCC  05 B7    	 JMP $0D84
;--------------------------	
0DCE  20 DC 11   JSR $11DC		;return to SCPU Execution mode
0DD1  04 D6 0E	 JMP $0ED6     
0DD3  0E FF
0DD5  60 				;TABLE 
0DD6  60         
0DD7  00         
0DD8  80 00      
0DDA  00         
0DDB  00         
0DDC  00         
0DDD  00         
0DDE  00 
0DDF  10 00      
0DE1  00         
0DE2  00

0DE3  7D 3D 3C   			;TABLE
0DE6  3C 73 32   
0DE9  7C 38 70   
0DEC  30 10      
0DEE  10 00      
0DF0  80
 
0DF1  02      				;TABLE
0DF2  02 02      
0DF4  03         
0DF5  02 03      
0DF7  02 03      
0DF9  01 02      
0DFB  02 03      

0DFD  80 40				;TABLE     
0DFF  20 10 08   
0E02  04 02 
0E04  01 2A      
0E06  20 DC 11  			;return to SCPU Execution mode
0E09  18         
0E0A  05 05      
0E0C  C0
 
0E0D  00     				;TABLE
0E0E  08         
0E0F  04 0C      
0E11  14 1C      
0E13  00 
0E14  18         
0E15  00
0E16  10 00      
0E18  00
         
0E19  00				;TABLE         
0E1A  00         
0E1B  04 0C      
0E1D  14 1C
0E1F  14 1C      
0E21  08         
0E22  00         
0E23  00         
0E24  2C

;-------------------------	;SCPU 27
0E25  1F 	 NOP
0E26  1F   
0E27  04 B3 10   JMP $10B3

0E2A  09 40 02 42 06  			;called 10BD 
		 BRA $06 =$0E34  
0E2F  09 48 02 2C 06
		 BRA $06 =$0E39     
0E34  09 2C 02 E2 4D
		 BRA $4D =$0E85   
0E39  19 14   
0E3B  09 40 02 42 2B
		 BRA $2B =$076A     				
0E40  24 20 00 				;STROUT ' '      
0E43  04 32 14	 JMP $1432    
0E46  44      
0E47  24 20 00
					
0E4A  09 4C 02 2C 59
		 BRA $59 =$0EA7    
						 
0E4F  25 50   
0E51  09 4C 02 42 0C
		 BRA $0C =$0E61    
						 
0E56  25 51   
0E58  09 4C 02 74 09
		 BRA $09 =$0E67          
0E5D  25 52    
0E5F  05 0A 
     
0E61  24 20 20 00 			;?'  ' 
						  
0E65  24 20 20 00  
0E69  1F         
0E6A  09 42 02 F0 57
		 BRA $57 =$0EC5     
						 					
0E6F  24 20 00 				;?' '     
0E72  1B 02 				;PRINT OUT LINE OF TEXT      
0E74  03 42 F0	 MOV          
						 					 
0E77  26 20 0C     
0E7A  0A 06 F4 06 
						 
0E7E  09 40 02 42 1C
		 BRA $1C =$0E9E    
						 
0E83  05 16	 JMP   
0E85  0A 44 4C 44       
0E89  11
						 
0E8A  13 40       
					
0E8C  09 40 01 74 04
		 BRA $04 =$0E94    
0E91  04 59 08   JMP $0859
0E94  04 20 06   JMP $0620   
0E97  FF

0E98  C0 10      
0E9A  0A 06 76 06        
0E9E  06 45 23 00    			;?'E#'        
					
0EA2  19 20 
0EA4  05 20  
0EA6  FF 
0E27  24 20 20 00			;?'  '    
0EAB  05 B5      
0EAD  09 48 02 74 32
		 BRA $32 =$0EE3     
0EB2  05 D7     
						 				
0EB4  09 1E 02 2C 04
		 BRA $04 =$0EBC     
0EB9  04 C5 08   JMP $08C5
						 
0EBC  03 42	 CMP #$42        
0EBE  4C      	 BEQ
0EBF  03 20 	 CMP #$20
0EC1  50       	 BEQ
0EC2  04 5A 09 	 JMP $095A
0EC5  24 OD      			;?CR
0EC7  05 AF   	 JMP
0EC9  FF        
0ECA  FF         
0ECB  FF         
;--------------------------		;called 0C6F
0ECC  B1 00      LDA ($00),Y
0ECE  38         SEC
0ECF  A6 34      LDX $34
0ED1  E9 30      SBC #$30
0ED3  4C 72 0C   JMP $0C72
;--------------------------		;called 0DD1
0ED6  18         
0ED7  13         
0ED8  15 A4      
0EDA  1E 
0EDB  4C B1 0D   		
0EDE  13 00   
0EE0  04 DC 0C   JMP $0CDC 
0EE3  03 42

0EE5  3E A7 05   ROL $05A7,X
0EE8  A2 00      LDX #$00
0EEA  00         BRK
0EEB  00         BRK
0EEC  13 00       
					
0EEE  04 DC 0C	 JMP $0CDC     
0EF1  01 2A 	 CMP #$2A
0EF3  0A	 BEQ  
0EF4  01 22      CMP #$22
0EF6  04	 BEQ
0EF7  04 58 0C 	 JMP $0C58          
0EFA  04 C8 0C	 JMP $0CC8
  
0EFD  03 44 7E   MOV
;-------------------------		;6502 OP CODE TBL 
 
0F00  04 EC 0E JMP $0EEC

0F03 > FF 40 06 00 FF E3 06 61 00 74 08 21 00 
0F10 > 44 09 02 03 FB 0C 90 0D 0B 0D B0 0D 59 0D F0 0D 
0F20 > FC 0D 20 09 91 0E 30 0D B5 0E D0 0D 0C 0F 10 0D 
0F30 > 5B 0F 00 0C F3 0F 50 0D 03 10 70 0D A3 14 18 0C 
0F40 > A4 14 D8 0C A9 14 58 0C B6 14 B8 0C D8 14 C1 00 
0F50 > 58 15 E0 08 59 15 C0 08 CB 19 C2 02 E0 19 CA 0C 
0F60 > E1 19 88 0C AA 21 41 00 73 3A E2 02 88 3A E8 0C 
0F70 > 89 3A C8 0C 98 40 40 0A 8A 41 14 0B A1 4B A1 00 
0F80 > B8 4B A2 04 B9 4B A0 06 0A 4E 42 03 E8 59 EA 0C 
0F90 > 91 60 01 00 00 64 00 FF 41 65 48 0C 50 65 08 0C 
0FA0 > E1 65 68 0C F0 65 28 0C E4 72 22 03 EA 72 62 03 
0FB0 > A9 73 40 0C B3 73 60 0C C0 76 00 FF 13 77 E1 00 
0FC0 > 8B 77 38 0C 8C 77 F8 0C 91 77 78 0C E1 79 81 01 
0FD0 > F8 79 82 05 F9 79 80 07 40 7D AA 0C 41 7D A8 0C 
0FE0 > 10 80 BA 0C C1 80 8A 0C D3 80 9A 0C E9 80 98 0C 
0FF0 > 00 96 00 FF 40 9C 00 FF FF FF FF FF FF FF FF FF
;--------------------------
1000  03 2C 4C	 MOV $2C-$4C	         
1003  13 00 	 INC $00
1005  9C	 JSR ($07B8)=$095D	;SKIP SPACES
1006  01 3D      CMP #$3D
1008  04 	 BEQ
1009  04 B7 08   JMP $08B7
100C  13 00      INC $00
100E  9C	 JSR ($07B8)=$095D	;SKIP SPACES
100F  A0	 JSR ($07C0)=$0C30
1010  13 01  	 INC $01
1012  83	 JSR ($07C0)=$0C30      
1013  04 				;???
1014  04 E6 08   JMP $08E6       
1017  15 	 MC6502 
1018  A9 3F      LDA #$3F         
				 
101A  24 ED      BIT $ED
101C  F0 07      BEQ $1025
101E  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
1021  18 84        
1023  05 73      JMP        
					
1025  4C 
1026  30 11      INC $11
1028  03 2C 4C   MOV $2C $4C     
102B  13 00	 INC $00  
102D  9C 	 JSR ($07B8)=$095D	;SKIP SPACES
102E  A0	 JSR ($07C0)=$0C30 
102F  68 
1030  01 83	 CMP #$83       
1032  04	 BEQ 
1033  04 E6 08   JMP $08E6
1036  03 02 00	 MOV $02 $00         
1039  9C	 JSR ($07B8)=$095D 	;SKIP SPACES
103A  A1 02	 JSR ($07C2)=$0AF0    
						  
103C  1F         NOP
103D  9D 	 JSR ($07BA)=$0989
103E  0E 0D 0C 0B

1042  04 6B 14	 JMP $146B
1045  8E     	 JSR ($079C)=$04C0
1046  74 78     



1048  0C 26 1E   
104B  01 05      
104D  4A         
104E  15 	 MC6502 
104F  A2 03   	 LDX #$03
1051  A5 6D      LDA $6D
1053  D5 D6      CMP $D6,X
1055  D0 06      BNE $105D
1057  A5 6C      LDA $6C
1059  D5 DA      CMP $DA,X
105B  F0 05      BEQ $1062
105D  CA         DEX
105E  10 F1      BPL $1051
1060  30 42      BMI $10A4
1062  B5 DE      LDA $DE,X
1064  85 4C      STA $4C
1066  86 1E      STX $1E
1068  A9 00      LDA #$00
106A  85 1F      STA $1F
106C  20 DC 11   JSR $11DC		;return to SCPU Execution mode
;--------------------------		;SCPU OP-CODE & DATA
106F  9C	 JSR ($07B8)=$095D 	;SKIP SPACES
1070  09 1E 05 2C 04
		 BRA $04 =$1078
1075  A7      	 JSR (07CE)=$0E25
1076  05 39 	 JMP $10B0     
1078  04 30 12   JMP $1230
		 
107B  15 	 MC6502
107C  A5 1E      LDA $1E
107E  C9 03      CMP #$03
1080  D0 08      BNE $108A
1082  A5 50      LDA $50
1084  A4 51      LDY $51
1086  85 51      STA $51
1088  84 50      STY $50
108A  20 DC 11   JSR $11DC		;return to SCPU Execution mode
;--------------------------		;SCPU OP-CODE & DATA
108D  A7         JSR (07CE)=$0E25
108E  01 2C      CMP $2C
         0A	 BEQ $109A
1091  01 83      CMP $83
         18      BEQ $10AB      
1094  18 07      ERR   
1096  1F	 NOP 
1097  04 AA 10   JMP $10AA
109A  13 00	 INC $00     
109C  05 DB      JMP $1078
109E  03 2C 4C	 MOV $2C $4C        
10A1  04 B0 10   JMP $10B0
10A4  20 DC 
10A6  11	 RTS 
  
10A7  03 2C 4C   MOV $2C $4C
10AA  A7    	 JSR (07CE)=$0E25	;from $1139
10AB  8D 04	 JSR (079A)=$047C	;??? 
10AD  04 5D 08	 JMP $085D		;???   
10B0  04 AD 0E   JMP $0EAD

10B3  09 40 05 74 06
		 BRA $06 =$10BD
10B8  09 48 03 74 04      		;???
		 BRA $04 =$10C0
10BD  04 2A OE   JMP $0E2A
10CO  09 48 02 74 0C
		 BRA $0C =$10D0		;???        
10C5  0A 44 70 1C ADD (001C,D)=(0044,5)+(0070,1) 
 
10C9  8E 4C 72 1C JSR (079C)=$04C0 
10CD  04 34 0E   JMP $0E34

10D0  15 	 MC6502
10D1  88         DEY			;A2 CMD here from $10C0 ?
10D2  46 3E      LSR $3E
10D4  A5 4C      LDA $4C
10D6  85 E4      STA $E4
10D8  B0 13      BCS $10ED
10DA  C6 E4      DEC $E4		;here for A2 at end of 1 record
10DC  30 3B      BMI $1119
10DE  A6 D1      LDX $D1
10E0  B9 50 00   LDA $0050,Y
10E3  95 B8      STA $B8,X
10E5  C8         INY
10E6  E8         INX
10E7  86 D1      STX $D1
10E9  E0 18      CPX #$18		;24 data bytes per record
10EB  D0 ED      BNE $10DA
10ED  A6 D1      LDX $D1
10EF  D0 03      BNE $10F4
10F1  4C 6A 12   JMP $126A

10F4  A9 3B      LDA #$3B		; ';' record start code
10F6  20 43 03   JSR $0343		;Print it
10F9  8A         TXA
10FA  20 7D 12   JSR $127D		;? '18' record length
10FD  A2 02      LDX #$02
10FF  B5 67      LDA $67,X		;data recrd start ADD lo hi
1101  20 7D 12   JSR $127D		;? start address XX
1104  CA         DEX
1105  D0 F8      BNE $10FF
1107  B5 B8      LDA $B8,X		; 
1109  20 7D 12   JSR $127D		;? data byte
110C  E8         INX
110D  C6 D1      DEC $D1
110F  D0 F6      BNE $1107		;loop for record
1111  A2 D3      LDX #$D3		;end of data record reached
1113  20 B0 0B   JSR $0BB0		;? checksum HI
1116  4C 59 12   JMP $1259		;? checksum LO, 6 NULLS
								;loop to $10DA for next record.
1119  20 DC 11   JSR $11DC		;return to SCPU Execution mode
111C  04 85 0E 	 JMP $0E85     
111F  00
;-------------------------- 		;ASM CMD cont from 115C
1120  03 2C 48	 MOV $2C $48
1123  96 06 02 07 JSR (07AC)=$0626        
1127  04 14 06	 JMP $0614
     
1129  10 48 FB 	 IND			;INPUT 16 BIT DEC to XX  
       
112D  04 50 08   JMP $0850     

1130  20 DC 11   JSR $11DC		;return to SCPU Execution mode
1133  03 42 3E   MOV $42-$3E   
1136  03 6A 44   MOV $6A-$44
1139  04 AA 10   JMP $10AA
	        
113C  96 03 02 01 JSR (07AC)=$0626  
1140  97	 JSR  (07AE)=$02CB       
				 
				 
1141  02 3D 	 CMP #$3D		;'='
         04	 BEQ $1147  
1144  04 14 0A	 JMP $0A14
 
1147  04 1F OA	 JMP $0A1F
				 
114A  13 00 	 INC $00
				 
114C  A1 06	 JSR (07C2)=$0AF0   
114E  18 1A      ERR           
				 
1150  04 A7 10   JMP $10A7
		 
1153  04 4E 10   JMP $104E
;--------------------------	;A ASSEMBLE CMD
1156  07 0D  	 PRINT 'CR'
1158  1F 	 NOP
1159  03 42 3E   MOV $42-$3E     
115C  04 20 11   JMP $1120

115F  00      
1160  A2 00      LDX #$00		;COLD START
1162  8A         TXA
1163  95 00      STA $00,X		;init PG0 =00
1165  E8         INX
1166  D0 FB      BNE $1163
1168  BC 90 12   LDY $1290,X		;ADD offset
116B  BD C8 12   LDA $12C8,X		;DATA
116E  99 00 00   STA $0000,Y		
1171  E8         INX
1172  E0 38      CPX #$38		;INIT 56 PG0 locations with DATA
1174  D0 F2      BNE $1168
1176  20 1A 14   JSR $141A
1179  A0 00      LDY #$00		;called @ 02A6 02B5 039D 11C8 11E8
117B  4C 2C 03   JMP $032C		;init NXTXTADD from $1A,B,ASL SCPU OP CODE returns 117E
 
;--------------------------;SCPU EXECUTE;contin cold start from above
117E  C9 4F      CMP #$4F		;called @ 0339 only
1180  90 05      BCC $1187		;always ? 		
1182  A6 24      LDX $24		;FUNC 28 - 7F execute via 1186 ?; X=PCL
1184  A4 25      LDY $25		;Y=PCH

1186  00         BRK			;SOFT BRK 01C0/0130= ?? 28- 7F OP CODES

1187  18         CLC
1188  69 80      ADC #$80		;add SCPU OP Code
118A  85 E4      STA $E4
118C  A9 00      LDA #$00
118E  69 07      ADC #$07		;to SCPU FUNCTION ADD TBL base 0780
1190  85 E5      STA $E5		;to form FUNC ADD PTR in E4,E5
1192  B1 24      LDA ($24),Y	;SCPU OP CODE [=96] (0024,5 init to $0601)
1194  29 7F      AND #$7F		;mask b7
1196  4A         LSR A
1197  AA         TAX			;form offset in X
1198  BD EA 11   LDA $11EA,X		;TBL   [=41]
119B  B0 04      BCS $11A1
119D  4A         LSR A
119E  4A         LSR A
119F  4A         LSR A
11A0  4A         LSR A
11A1  29 0F      AND #$0F		;[=04]
11A3  85 2A      STA $2A		;SCPU offset RTS ??? [=04]
11A5  B1 24      LDA ($24),Y	;OP CODE
11A7  30 0E      BMI $11B7		;80-A7 =JSR REL
11A9  B1 E4      LDA ($E4),Y	;FUNC ADD L, from TBL 0780-07CF FUNC 00-$27
11AB  85 E6      STA $E6		;
11AD  C8         INY			;Y=1 
11AE  B1 E4      LDA ($E4),Y
11B0  85 E7      STA $E7		;FUNC ADD H
11B2  A2 00      LDX #$00
11B4  6C E6 00   JMP ($00E6)	;	;Go SCPU FUNC in (00E6) FUNC 00-$27,X=0,Y=1

;--------------------------		;OP CODES 80-A7 are SCPU code ?
11B7  A5 2A      LDA $2A		
11B9  48         PHA			;PUSH instruction length
11BA  A5 25      LDA $25
11BC  48         PHA			;PUSH return address
11BD  85 FB      STA $FB
11BF  A5 24      LDA $24
11C1  85 FA      STA $FA		;$00FA,B=$0601 CALL ADD
11C3  48         PHA
11C4  B1 E4      LDA ($E4),Y
11C6  85 24      STA $24		;PCL SCPU 
11C8  C8         INY
11C9  B1 E4      LDA ($E4),Y
11CB  85 25      STA $25		;PCH SCPU
11CD  D0 AA      BNE $1179		;always SCPU FUNCTION ENTRY

11CF  A5 2A      LDA $2A		;here from $15BE (multiple entries)
11D1  18         CLC
11D2  65 24      ADC $24		 
11D4  85 24      STA $24		;to PCL SCPU
11D6  A5 25      LDA $25
11D8  69 00      ADC #$00
11DA  D0 EF      BNE $11CB
;--------------------------		;SUB return to SCPU Execution mode
11DC  68         PLA
11DD  85 24      STA $24		;Pull PCL,H SCPU ADD
11DF  68         PLA
11E0  85 25      STA $25		;PCH SCPU
11E2  E6 24      INC $24		;PCL SCPU
11E4  D0 02      BNE $11E8		;(A)<>0
11E6  E6 25      INC $25		;PCH SCPU
11E8  D0 8F      BNE $1179		;(A)<>0 SCPU FUNCTION ENTRY

;--------------------------		;TABLE ref @ 1198 RTS offsets for $2A 
11EA  13 33 32 3F F5 44   		;for OP CODES 00-$27
11F0  12 41 31 22 21 41 22 22      
11F8  15 51 22 31 F2 31 00 00                    
;-------------------------
1200  49 FE      EOR #$FE
1202  D0 0C      BNE $1210
1204  85 7F      STA $7F		;
1206  B1 0C      LDA ($0C),Y
1208  85 7E      STA $7E		;$007E,F=
120A  20 DC 11   JSR $11DC		;SCPU MODE RETURN.Execute following P-code		
;--------------------------		;SCPU OP-CODE & DATA
120D  04 18 0A	 JMP $0A18
;--------------------------	

1210  A5 45      LDA $45
1212  F0 10      BEQ $1224
1214  C8         INY
1215  91 0C      STA ($0C),Y
1217  88         DEY
1218  A5 44      LDA $44
121A  91 0C      STA ($0C),Y
121C  88         DEY
121D  A5 6F      LDA $6F
121F  91 0C      STA ($0C),Y
1221  4C 7B 0B   JMP $0B7B
;--------------------------
1224  A5 44      LDA $44
1226  91 0C      STA ($0C),Y
1228  88         DEY
1229  A9 FE      LDA #$FE
122B  91 0C      STA ($0C),Y
122D  4C 7B 0B   JMP $0B7B
;--------------------------		;SCPU OP-CODE & DATA 
1230  01 27      CMP #$27		;SINGLE QUOTE '
	  09	 BEQ $123B
1233  A0 0D	 JSR ($07C0)=$0C30      
1235  03 6A 50 	 MOV $6A-$50
1238  04 7B 10	 JMP $107B     	       
123B  09 1E 02 42 05  			;???
		 BRA $05 =$1244
1240  1F 	 NOP     
1241  04 E6 08	 JMP $08E6     
1244  13 00	 INC $00         
1246  22 00 72    			;?? 
1249  A7         JSR ($07CE)=$0E25      
124A  13 00      INC $00
124C  01 27      CMP #$27 		;SINGLE QUOTE '
	  03	 BEQ $1251        
124F  05 F6      JMP $1246
1251  13 00 	 INC $00        
1253  01 27 F1	 CMP #$27		;SINGLE QUOTE '
		 BEQ $1246     
1256  04 8E 10	 JMP $108E   

;--------------------------		;used by A2 checksum  CALLED $1116
1259  CA   	 DEX 
125A  20 B0 0B   JSR $0BB0		;? checksum LO	
125D  20 3C 03   JSR $033C		;? CRLF
1260  A2 06      LDX #$06
1262  A9 00      LDA #$00
1264  20 43 03   JSR $0343		;? 6 NULLS
1267  CA         DEX
1268  D0 F8      BNE $1262
126A  86 D2      STX $D2		
126C  86 D3      STX $D3		;$D2,3=00 reset data pointer
126E  18         CLC
126F  98         TYA
1270  65 44      ADC $44
1272  85 68      STA $68
1274  A9 00      LDA #$00
1276  65 45      ADC $45
1278  85 69      STA $69		;$68,9= update record data start ADD
127A  4C DA 10   JMP $10DA		;loop for next record
;--------------------------
127D  48         PHA
127E  18         CLC
127F  65 D2      ADC $D2
1281  85 D2      STA $D2
1283  A9 00      LDA #$00
1285  65 D3      ADC $D3
1287  85 D3      STA $D3		;update data pointer
1289  68         PLA
128A  4C B2 0B   JMP $0BB2		;? data byte and return
;--------------------------
128D  00         BRK
128E  00         BRK
128F  00         BRK

;--------------------------;0PG LOCN
       0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F 
1290  02 16 17 18 19 24 25 2E 2F 38 3A 3C 42 4A 4E 4F 
12A0  58 5B 5D 5E 60 62 65 67 FC 72 74 76 78 7A D4 D6 
12B0  D7 D8 D9 DA DB DC DD DE DF E0 E1 EA EE F2 F4 FF 
12C0  00 80 0A 0B 70 71 1A 1B                         
;--------------------------;0PG DATA
       8  9  A  B  C  D  E  F  0  1  2  3  4  5  6  7

12C8  80 7E 32 FF 5F 5C 06 FF FF 14 36 0A 01 03 EA EA
12D8  80 B0 40 20 40 10 0C 03 42 50 02 0C 7E 6C 44 21
12E8  10 92 19 74 7C 2A 69 00 01 02 02 04 37 05 06 FF
12F8  80 0D 00 00 00 00 7E 32 

;12C9,A 7E 32 				;SRC START Lo,HI	***
;12CB,C FF 5F 				;HIMEM LO,HI	***
;12FC,D 00 00				;OBJ BIAS for ASM   
;12FE   7E 32      			;SRC END PTR increments as text input to editor	***

1300  20 67 13	 JSR $1367
1303  20 F7 2C   JSR $2CF7
1306  AD 79 32   LDA $3279
1309  8D C9 12   STA $12C9
130C  AD 7A 32   LDA $327A
130F  8D CA 12   STA $12CA
1312  AD 7B 32   LDA $327B
1315  8D FE 12   STA $12FE
1318  AD 7C 32   LDA $327C
131B  8D FF 12   STA $12FF
131E  4C 28 15   JMP $1528		;SETERR $1527 JMP $0200
;--------------------------
1321  20 F7 2C   JSR $2CF7		;SWAP01
1324  20 3E 13   JSR $133E
1327  20 6A 2D   JSR $2D6A		;
132A  8A         TXA
132B  20 92 2D   JSR $2D92		;
;--------------------------------;
132E  20 73 2D   JSR $2D73
1331 20 54 52 41 43 4B 28 53 29 00   	;TRACK(S)
133B  4C 51 2A   JMP $2A51		;OS65D3
;--------------------------------;
133E  AD C9 12   LDA $12C9
1341  8D 79 32   STA $3279
1344  AD CA 12   LDA $12CA
1347  8D 7A 32   STA $327A
134A  AD FE 12   LDA $12FE
134D  8D 7B 32   STA $327B
1350  AD FF 12   LDA $12FF
1353  8D 7C 32   STA $327C
1356  A2 00      LDX #$00
1358  AD 7C 32   LDA $327C
135B  38         SEC
135C  E9 32      SBC #$32
135E  E8         INX
135F  E9 08      SBC #$08
1361  B0 FB      BCS $135E
1363  8E 7D 32   STX $327D
1366  60         RTS
;--------------------------
1367  20 73 2D   JSR $2D73		;STROUT

1369 2D 0D 0A 4F 53 49 20 20  -  OSI  
1371 36 35 30 32 20 20 20 41  6502   A
1379 53 53 45 4D 42 4C 45 52  SSEMBLER
1381 0D 0A 43 4F 50 59 52 49    COPYRI
1389 47 48 54 20 31 39 37 36  GHT 1976
1391 20 42 59 20 4F 53 49 00   BY OSI 

1399  A9 13      LDA #$13
139B  8D 06 2C   STA $2C06
139E  A9 03      LDA #$03
13A0  8D 05 2C   STA $2C05
13A3  A9 17      LDA #$17
13A5  8D 14 2C   STA $2C14
13A8  A9 00      LDA #$00
13AA  8D 13 2C   STA $2C13
13AD  A9 2A      LDA #$2A
13AF  8D 0D 2C   STA $2C0D
13B2  A9 C0      LDA #$C0
13B4  8D 0C 2C   STA $2C0C
13B7  AD 00 23   LDA $2300		;DOS HIMEM
13BA  8D CC 12   STA $12CC		;HIMEM
13BD  A9 FF      LDA #$FF
13BF  8D CB 12   STA $12CB
13C2  A9 32      LDA #$32
13C4  8D 7C 32   STA $327C
13C7  8D 7A 32   STA $327A
13CA  A9 7E      LDA #$7E
13CC  8D 7B 32   STA $327B
13CF  8D 79 32   STA $3279
13D2  60         RTS
;--------------------------		;from 0479
13D3  AD 0C 14   LDA $140C		;TABCNT
13D6  F0 08      BEQ $13E0
13D8  CE 0C 14   DEC $140C		;TABCNT
13DB  A9 20      LDA #$20
13DD  4C 43 23   JMP $2343
13E0  20 40 23   JSR $2340		;INPUT     *=$15C2 for CEGMON Editor *
13E3  C9 5F      CMP #$5F		;Backspace
13E5  D0 1A      BNE $1401
13E7  48         PHA
13E8  A9 08      LDA #$08
13EA  20 43 23   JSR $2343
13ED  20 43 23   JSR $2343
13F0  A9 20      LDA #$20
13F2  20 43 23   JSR $2343
13F5  20 43 23   JSR $2343
13F8  A9 08      LDA #$08
13FA  20 43 23   JSR $2343
13FD  20 43 23   JSR $2343
1400  68         PLA
1401  A2 05      LDX #$05
1403  DD 14 14   CMP $1414,X		;CTRL +E - +I TABS
1406  F0 05      BEQ $140D
1408  CA         DEX
1409  10 F8      BPL $1403
140B  60         RTS								  

;--------------------------
140C  00         BRK			;TAB count store
140D  E8         INX
140E  E8         INX
140F  8E 0C 14   STX $140C		;TABCNT
1412  D0 C7      BNE $13DB

;--------------------------
1414  05 12      			;CTRL TABS +E +R
1416  14 19      			;+T +Y
1418  15 				;+U 
1419  09				;+I 

	     
141A  A5 16      LDA $16		;here from $1176
141C  85 10      STA $10
141E  A5 17      LDA $17
1420  85 11      STA $11
1422  A5 2C      LDA $2C
1424  85 12      STA $12
1426  A5 2D      LDA $2D
1428  85 13      STA $13
142A  60         RTS

;--------------------------
142B  18         
142C  10 14      
142E  4C
142F  04 84 0D   JMP $0D84
1432  15 	 MC6502
1433  A5 3E	 LDA $3E  
1435  D0 04	 BNE $143B   
1437  A5 4C      LDA $4C
1439  F0 0E      BEQ $1449
143B  A9 00      LDA #$00
143D  85 3E      STA $3E
143F  20 DC 11   JSR $11DC		;return to SCPU Execution mode
1442  25 45      
1444  25 44      
1446  04 47      JMP $0E47
1449  A9 00   	 LDA #$00		;*** modified at $145B,71,80
144B  D0 0C      BNE $1459
144D  20 DC 11   JSR $11DC		;return to SCPU Execution mode
1450  24 20      
1452  20 20 20   
1455  00         BRK

;--------------------------
1456  04 47 0E	 JMP $0E47 		;???
1459  A9 00      LDA #$00
145B  8D 4A 14   STA $144A
145E  20 DC 11   JSR $11DC		;return to SCPU Execution mode
1461  25 6B      
1463  25 6A      
1465  24 3D      
1467  00         BRK
1468  04 4A 0E	 JMP $0E4A      
146B  03 6A 7E    
146E  15 	 MC6502 
146F  A9 01      LDA #$01
1471  8D 4A 14   STA $144A
1474  20 DC 11   JSR $11DC		;return to SCPU Execution mode	    
1477  04 45 10	 JMP $1045      
147A  03 2C 44         
147D  15 	 MC6502   
147E  A9 00      LDA #$00
1480  8D 4A 14   STA $144A
1483  85 3E      STA $3E
1485  20 DC 11   JSR $11DC		;return to SCPU Execution mode
1488  04 5C 08	 JMP $085C 

;-------------------------------- ;CMD EXTENSIONS             
148B  02 45	 CMP #'E W/($00,6)	;EXIT $149A
	 0D	 BEQ $149A
148E  02 48 	 CMP #'H W/($00,6)	;HIMEM CMD $149E
1490     0E	 BEQ $149E
1491  02 4D 	 CMP #'M W/($00,6) 	;MEM BIAS $14B2 
1493  	 1F      BEQ $14B2 
1494  02 21	 CMP #'!W/($00,6)   	;DOS !CMD $14C3
1496     2D	 BEQ $14C3
1497  04 17 06   JMP $0617		;CMD ERR
;--------------------------------;EXIT
149A  15 	 MC6502         
149B  4C 21 13   JMP $1321		;? ' xx TRACKS'
;--------------------------------;HIMEM 
149E  15 	 MC6502       
149F  20 E2 14   JSR $14E2   
14A2  8E CC 12   STX $12CC
14A5  86 19      STX $19
14A7  8C CB 12   STY $12CB		 ;$12CB,C = 
14AA  84 18      STY $18		 ;$0018,9 =
14AC  20 DC 11   JSR $11DC		 ;return to SCPU Execution mode
14AF  04 20 06   JMP $0620		 ; ? '.' Loop CMDs
;--------------------------------;MEM BIAS
14B2  15 	 MC6502      
14B3  20 E2 14   JSR $14E2
14B6  8E FD 12   STX $12FD
14B9  86 71      STX $71
14BB  8C FC 12   STY $12FC		;$12FC,D = $
14BE  84 70      STY $70		;$0071,2 = $
14C0  4C AC 14   JMP $14AC
;--------------------------------;DOS !
14C3  15 	 MC6502      
14C4  20 F7 2C   JSR $2CF7
14C7  20 3E 13   JSR $133E
14CA  A9 2F      LDA #$2F
14CC  85 E2      STA $E2
14CE  A9 FA      LDA #$FA
14D0  85 E1      STA $E1		;$00E1,2 =$2FFA
14D2  A9 00      LDA #$00
14D4  8D E5 2C   STA $2CE5		;$2CE5 =$00
14D7  A9 0A      LDA #$0A
14D9  20 43 23   JSR $2343		;? LF
14DC  20 84 2A   JSR $2A84		;EXCOM
14DF  4C 03 13   JMP $1303		;WARM
;--------------------------------;
14E2  A0 01      LDY #$01
14E4  20 F3 14   JSR $14F3
14E7  AA         TAX
14E8  20 F3 14   JSR $14F3
14EB  A8         TAY
14EC  A5 85      LDA $85
14EE  C9 0D      CMP #$0D
14F0  D0 2E      BNE $1520
14F2  60         RTS
14F3  20 03 15   JSR $1503
14F6  0A         ASL A
14F7  0A         ASL A
14F8  0A         ASL A
14F9  0A         ASL A
14FA  8D 01 15   STA $1501
14FD  20 03 15   JSR $1503
1500  09 00      
1502  60         RTS
1503  B9 80 00   LDA $0080,Y
1506  C8         INY
1507  C9 30      CMP #$30
1509  30 11      BMI $151C
150B  C9 3A      CMP #$3A
150D  30 0A      BMI $1519
150F  C9 41      CMP #$41
1511  30 09      BMI $151C
1513  C9 47      CMP #$47
1515  10 05      BPL $151C
1517  E9 06      SBC #$06
1519  29 0F      AND #$0F
151B  60         RTS
151C  68         PLA
151D  68         PLA
151E  68         PLA
151F  68         PLA
1520  68         PLA
1521  68         PLA
1522  20 DC 11   JSR $11DC		;return to SCPU Execution mode
1525  04 17 06   JMP $0617
;--------------------------------;  
1528  A9 32	 LDA #$32    
152A  A0 15      LDY #$15    
152C  20 7D 2A   JSR $2A7D		;SETERR $1532
152F  4C 00 02   JMP $0200
;--------------------------------;
1530  80
1531  15 	 MC6502
1532  20 F7 2C   JSR $2CF7
1535  20 6A 2D   JSR $2D6A
1538  4C AC 14   JMP $14AC
;--------------------------------;
153B  20 42 15   JSR $1542		;CALLED @ $0336
153E  B1 24      LDA ($24),Y
1540  0A         ASL A
1541  60         RTS
;--------------------------
1542  AD 25 23   LDA $2325		;KPDO
1545  D0 09      BNE $1550
1547  AD 00 FC   LDA $FC00		;ACIA
154A  4A         LSR A
154B  90 0D      BCC $155A
154D  20 FF 24   JSR $24FF		;TERMIN
1550  49 03      EOR #$03
1552  D0 ED      BNE $1541
1554  8D 25 23   STA $2325
1557  4C 00 02   JMP $0200
155A  20 60 15   JSR $1560
155D  4C 50 15   JMP $1550
;--------------------------------;
1560  A9 E1      LDA #$E1
1562  20 6D 15   JSR $156D
1565  50 05      BVC $156C
1567  4A         LSR A
1568  4A         LSR A
1569  4A         LSR A
156A  90 F6      BCC $1562
;--------------------------------;
156C  60         RTS
156D  8D 00 DF   STA $DF00
1570  2C 00 DF   BIT $DF00
1573  60         RTS
;--------------------------------;
1574 -157F = 00         				

;code from 0200 moved here 1580 for CEGMON compatibility.
										
1580  4C 60 11   JMP $1160		;called 1157,152F

;SCPU 0 INPUT an fill LINE BUFFER
;--------------------------------
1583  A0 01      LDY #$01		;reset Y buffer offset
1585  88         DEY                	;Y=BUFFOFFSET
1586  30 FB      BMI $1583          	;reset Y buffer offset 
1588  10 02      BPL $158C          
158A  85 FF      STA $FF            	;FF=(A) if <20,7F
158C  20 88 05   JSR $0588				;do INPUT/OUTPUT @13D3
158F  91 02      STA ($02),Y        	;BUFFER @ $0080.(here after INIT Y)
1591  C9 0D      CMP #$0D           	;CR ?
1593  F0 20      BEQ $15B5          	;do EOL
1595  C9 5F      CMP #$5F           	;Rubout ?
1597  F0 EC      BEQ $1585          	;DEC Y OFFSET -remove char
1599  C9 5E      CMP #$5E           	;^SHIFT-N ?
159B  F0 E6      BEQ $1583          	;line DEL
159D  C9 09      CMP #$09		;CTRL-I ?
159F  F0 08      BEQ $15A9          	;do TAB
15A1  C9 7F      CMP #$7F           	;Delete ?
15A3  F0 E5      BEQ $158A          	;yes store CHARTMP
15A5  C9 20      CMP #$20           	;SPACE ?,TAB yes store
15A7  30 E3      BMI $158C          	;CTRL chars ? but dont store
15A9  C8         INY                	;for next char store
15AA  C0 38      CPY #$38           	;BUFF length full ?
15AC  D0 DE      BNE $158C          	;no get next char and store
15AE  A9 07      LDA #$07
15B0  20 43 03   JSR $0343
15B3  D0 D0      BNE $1585

15B5  A9 0A      LDA #$0A		;CR input
15B7  88         DEY
15B8  30 F6      BMI $15B0		;CR only
15BA  A5 02      LDA $02
15BC  85 00      STA $00
15BE  4C CF 11   JMP $11CF		;Advance PC and execute				;
15C1  00         BRK
